/*******************************************************/
/* HW-5400 with AD9850 DDS (100 mhz osc)               */
/* Freescale (HC9S12DJ64)  0X3C9                       */
/*                                                     */
/* Written: Darrin Kohn (KE9NS)                        */
/* Sofware Ver: 1.0.1005    10/25/05                   */
/*                                                     */
/* rebuilt Ver 2.0        2/10/2012                    */
/*         from LO DDS Board hiwave raw code           */
/*                                                     */
/* Use Codewarrior V4.5 for perfect original code match*/
/* -Cu -Ot -Ou -Oi -OiLib=a -OnCstVar -OnPMNC -PEDIV   */
/*                                                     */
/*******************************************************/

#include <hidef.h>
#include <register.h>
#include <stdlib.h>   
#include <ctype.h>
#include <String.h>
#include <stdio.h>                        
#include <math.h>

#pragma CODE_SEG DEFAULT

// --------- PORTATD0               J2 4pos molex plug ( 1=+5v, 2=AD01, 3=AD00, 4=GND )
// PAD7 = 
// PAD6 = 
// PAD5 = 
// PAD4 =
// PAD3 =
// PAD2 =
// PAD1 =   
// PAD0 =                  RIT ADJ POT
                                                   

// --------- PORTA                 J6 9pos molex plug ( 1=GND, 2-9 = PA7-PA0 )
// PA7 =  O              RX mute 
// PA6 =  O	             HW-5400 Display (Seg g & '-') 					 a
// PA5 =  O	             HW-5400 Display (Seg f) 					     f   b
// PA4 =  O	             HW-5400 Display (Seg e) 						     g              
// PA3 =  O		           HW-5400 Display (Seg d & 'M') 			   e   c        
// PA2 =  O	             HW-5400 Display (Seg c) 					    	 d                        
// PA1 =  O              HW-5400 Display (Seg b) 
// PA0 =  O              HW-5400 Display (Seg a & '<') 


// --------- PORTB                 J4 9pos molex plug ( 1=GND, 2-9 = PB0-PB7 )
// PB7 =  I		           Send 0 = 10 HZ  digit & (band 0=80,1=40,2=30,3=20,4=17,5=15,6=12,7=10)
// PB6 =  I              Send 1 = 100HZ  digit & (mode 14=Rev,13=Norm,12=cw-n,11=cw-w)  
// PB5 =  I              Send 2 = 1  Khz digit & (switches 1=D>M, 2=D><M, 4=Split)
// PB4 =  I              Send 3 = 10 Khz digit & (1=Fast tune)
// PB3 =  O              Send 4 = 100Khz digit & (keyboard scan V)
// PB2 =  O              Send 5 = 1  Mhz digit & (keyboard scan U)
// PB1 =  O              Send 6 = 10 Mhz digit & (keyboard scan R)
// PB0 =  O              Send 7 = symbol1 digit (u,c,l,-,o)
//                       Send 8 = symbol2 digit (<,-,M)


// --------- PORTE              Not connected
// PE7 =
// PE6 = 
// PE5 = 
// PE4 =
// PE3 =
// PE2 =
// PE1 = 
// PE0 = 


// --------- PORTM             Not connected
// PM5 = 
// PM4 =
// PM3 =
// PM2 =
// PM1 = 
// PM0 = 


// --------- PORTP              Not connected
// PP7 = 
// PP5 =  
// PP4 = 
// PP3 = 
// PP2 = 
// PP1 =  
// PP0 = 
				 

// --------- PORTT            Connected to IF DDS chip AD9850 & 100mhz tcox 
// PT7 = 
// PT6 = 
// PT5 = 
// PT4 = 
// PT3 = 
// PT2 =  O          DDS freq update (pulse 0-1-0)
// PT1 =  O          DDS serial clk  (pulse 0-1-0)
// PT0 =  O          DDS serial data (40 bit= 32data & 8bit control)


// --------- PORTJ           J3 2pos molex connector (1-2 = PJ7-PJ6 )
// PJ7 =  I   Knob 01 
// PJ6 =  I   Knob 02


// --------- PORTS           U10 4pos molex connector ( 1-4 = PS3-PS0 )
// PS0 =  I           TX Request  (1=TX, 0=RX)
// PS1 =  O           TX ON       (1=ON)
// PS2 =  O           Mode Select 1 (0=usb (E),1=cw-w(C,E),2=lsb (D),4=cw-n(F,E))
// PS3 =  O           Mode Select 0


/*******************************************************/
/*     EEPROM memory                                   */
/*     Read/Writes are 1 word at a time                */
/*     Eraseures are done 2 words at a time            */
/*                                                     */
/*     To program a LONG requires 8 bytes (to store 4) */
/*******************************************************/


#define _EE_USED       (*((volatile uint*) (0x1000)))       // 4096dec start of EEPROM  

#define _EE_BAND       (*((volatile uint*) (0x1004)))       // 4100dec high word for first memory 
#define _EE_BAND_L     (*((volatile uint*) (0x1008)))       // 4104dec low word for first memory

#define _EE_BAND1      (*((volatile uint*) (0x100c)))       // 4108dec high word for 2nd  memory 
#define _EE_BAND1_L    (*((volatile uint*) (0x1010)))       // 4112dec low word for 2nd memory


#define _EE_LFREQ      (*((volatile uint*) (0x1160)))       // 4448dec first word 



volatile uint *_EE_MEM = &_EE_BAND;                         // 0x800,1 pointer to beam pattern 


/*=======================================================================================================*/

#define ulng unsigned long
#define uint unsigned int
#define uchr unsigned char



/*******************************************************/
/*     .C function declarations                        */
/*******************************************************/


void HW5400_KEYBOARD(void);

void DDS_UPDATE(void);


void FREQ_TO_HZ(void);                                      // used to display freq
void HZ_TO_FREQ(void);

void FREQ_TO_HZ1(void);                                     // used by keypad
void HZ1_TO_FREQ(void);
void CHAR_TO_HZ(uint);               

/*=======================================================================================================*/


const ulng AM_IF =(ulng)8830000;     // AM  IF freq 8.830.000                  0x0086bc30  0x4048

// 2.8k filter  (2.825 khz wide @ 6db down)
const ulng USB_IF =(ulng)8831400;    // USB IF freq 8.831.400  (8831400 -6db)  0x0086c1a8
const ulng LSB_IF =(ulng)8828600;    // LSB IF freq 8.828.400  (8828600 -6db)  0x0086b6b8
const ulng CW_IF =(ulng)8830700;     // CW IF freq 8.830.700                   0x0086beec

// 4.0k filter  (4.275 khz wide @ 6db down)
const ulng USB4_IF =(ulng)8832138;   // USBW IF freq 8.832.000 (8832138 -6db)  0x0086c400
const ulng LSB4_IF =(ulng)8827863;   // LSBW IF freq 8.828.000 (8827863 -6db)  0x0086b460
const ulng CW4_IF =(ulng)8830700;    // CWW IF freq 8.830.700                  0x0086beec  0x4060

// 6.0k filter  (6.450 khz wide @ 6db down)
const ulng USB6_IF =(ulng)8833225;   // USBW IF freq 8.833.000 (8833225 -6db) 0x0086c400
const ulng LSB6_IF =(ulng)8826775;   // LSBW IF freq 8.827.000 (8826775 -6db) 0x0086b460
const ulng CW6_IF =(ulng)8830700;    // CWW IF freq 8.830.700                 0x0086beec  


// 2.8k filter  (2.825 khz wide @ 6db down)
const ulng USB_IFR =(ulng)8831400;    // USB IF freq 8.831.400  (8831400 -6db)  0x0086c1a8
const ulng LSB_IFR =(ulng)8828600;    // LSB IF freq 8.828.400  (8828600 -6db)  0x0086b6b8

// 4.0k filter  (4.275 khz wide @ 6db down)
const ulng USB4_IFR =(ulng)8832000;   // USBW IF freq 8.832.000 (8832138 -6db)  0x0086c400
const ulng LSB4_IFR =(ulng)8828000;   // LSBW IF freq 8.828.000 (8827863 -6db)  0x0086b460

// 6.0k filter  (6.450 khz wide @ 6db down)
const ulng USB6_IFR =(ulng)8833000;   // USBW IF freq 8.833.000 (8833225 -6db) 0x0086c400
const ulng LSB6_IFR =(ulng)8827000;   // LSBW IF freq 8.827.000 (8826775 -6db) 0x0086b460




const double FREQ_BITS  = 0xffffffff;                       // 4064  largest phase value   0x4f800000 double  0x4068
                                                           
const uint IF_CENTER_TX =  505;                                // 4068  center A/D value of IF control (on front panel)
const uint IF_CENTER_RX =  505;

const uint RIT_CENTER = 512;                                // 406a   center A/D value of RIT control (on front panel)       


//long FREQ_CLOCK = 1289648439;                               // 534b 0x802,3,4,5 (0x4cde7937) AD8951 DDS chip actual freq of reference clock input (was 99998000)
double FREQ_CLOCK = 116640230;                               // 116640184 534b 0x802,3,4,5 (0x4cde7937) AD8951 DDS chip actual freq of reference clock input (was 99998000)


ulng  FREQ[8][5] =                                          // 0x806-0x8a5(160 bytes) TX/RX Freq. Memories (4 per band + 1 split TX freq)
      {
        3500000, 3600000, 3700000, 3800000, 3900000,
        7100000, 7200000, 7300000, 7400000, 7500000,
        9600000, 9700000, 9800000, 9900000,10000000,
        14100000,14200000,14300000,14400000,14500000,
        18000000,18100000,18200000,18300000,18400000,
        21000000,21100000,21200000,21300000,21400000,
        24000000,24100000,24200000,24300000,24400000,
        27365000,27385000,27705000,28300000,28500000,
      };

uchr DIGIT[34]={ 63,6,91,79,102,109,124,7,127,103,    1,8,64,9,72,65,73,     88,28,24,92,32,2,    89,29,25,93,33,3,   8,0,0,0,0 }; // 0x8a6-0x8c4    0-9, <,m,-, <m,m-,<-,<m-  c,u,l,a,t,r,-c,-u,-l,-a,-t,-r _,blank,blank,blank,blank
                                                                                                    
uchr  BAND_LAST = 10;                                       // 0x8c5   Band that was in use before changing band selector

volatile uint  AD0=0;                                       // 0x8c6,7  A/D channel 0 input
volatile uint  AD1=0;                                       // 0x8c8,9  A/D channel 1 input
uint  RIT_LAST=0;                                           // 0x8ca,b  previous RIT value used for A/D noise filtering
uint  IF_LAST_TX=0;                                            // 0x8cc,d  previous IFShift value used for A/D noise filtering
uint  IF_LAST_RX=0;

ulng  DDS=0;                                                // 0x8ce,f,8d0,1   TX/RX Freq on DISPLAY
ulng  DDS1=0;			                                          // 0x8d2,3,4,5     Temp holder for DDS (used by HZ1 routines)

ulng  DDS_RX=0;                                             // 0x8d6,7,8,9   SPLIT RX Freq.
ulng  DDS_TX=0;                                             // 0x8da,b,c,d   SPLIT TX Freq.

uchr  LFREQ[8] = {0,0,0,0,0,0,0,0};                         // 0x8de,f,8e0,1,2,3,4,5  TX/RX Freq. memory pointer for FREQ[][]
   
uchr  FREQ_CHANGE=0;                                        // 0x8e6  used to update DDS output (1=freq changed)

uchr  SYMBOL1=0;                                            // 0x8e7  c,u,l,- indicators -=4 17=c,20=0,18=u,19=L
uchr  SYMBOL2=0;                                            // 0x8e8  <, m, - indicators

uchr  BAND=0;                                               // 0x8e9  0=80,1=40,2=30,3=20,4=17,5=15,6=12,7=10 meter band

uchr  MODE=0;                                               // 0x8ea  11=CW-W(CW),12=CW-N(AM),13=LSB,14=USB

uchr  MODE_LAST=0;                                          // 0x8eb  Mode that was in use before changing Mode selector

uchr  MEM=0;                                                // 0x8ec  split,d<>m,d>m = 11,13,14 (15=none)

uchr  MEM_LAST=0;                                           // 0x8ed  used to update DDS output when button pushed

uchr  TUNE=0;                                               // 0x8ee  14=fast tune (15=standard)

uchr  KEY=0;                                                // 0x8ef  Indicates which key was pressed (updated 1 time per push)
uchr  KEY1=0;                                               // 0x8f0  1 column of buttons
uchr  KEY2=0;                                               // 0x8f1  1 column of buttons
uchr  KEY3=0;											                        	// 0x8f2  1 column of buttons
uchr  KEY4=0;                                               // 0x8f3  Indicates currently held key (updated every scan)

volatile uchr ENTER_KEY=0;                                  // 0x8f4  DISPLAY digit place holder for keypad freq entry (7=start, 0=end)
volatile uchr KEY_DOWN=0;								                  	// 0x8f5  1=update KEY value 1 time 0=keypad released
volatile uchr KEY_PRESS=0;								                	// 0x8f6  1=keypad held down 0=released

uchr  MODE1=0;		                                          // 0x8f7  signal to BFO computer 0=AM,4=CW,8=USB,12=LSB

uchr  MEMORY=0;                                             // 0x8f8  1=memory button held down, 0=off

uchr  SPLIT=0;                                              // 0x8f9  1=split on, 0=off

uchr  RECEIVER=0;                                           // 0x8fa  0=receiver off, 1=on
uint  RX_COUNT=0;                                           // 0x8fb,c  counter to keep receiver off for short duration

uchr  WIDE = 1;                                             // 0x8fd  1=WIDE Filter, 0=Standard 2=6k

uchr  RXON = 0;                                             // 0x8fe  1= RX latch
uchr  TXON = 0;                                             // 0x8ff  1= TX latch

ulng  COUNTER = 0;                                          // 0x900,1,2,3  RIT Counter ???????

uchr  RITOFF = 0;                                           // 0x904  1=RIT off (use center value), 0=use A/D KNOB input

ulng  OFFSET= 0;                                            // 0x905,6,7,8     RIT offset


                                                            
// static ulng DDS_TEMP;                                    // 0x909,a,b,c      Freq_To_Hz()
// static ulng DDS_TEMP;                                    // 0x90d,e,f,910    Freq_To_Hz1()
// static double FREQ_F;                                    // 0x911,2,3,4      RF freq value
// static ulng FREQ_I;                                      // 0x915,6,7,8      IF freq value
// static ulng TEMP;	                                      // 0x919,a,b,c      temp counter
// static ulng RIT_VALUE;                                   // 0x91d,e,f,920    final RIT freq change
// static ulng IF_VALUE_TX;                                    // 0x921,2,3,4 
// static ulng DDS_TEMP;                                    // 0x925,6,7,8      chnage in DDS caused by RIT
 
                                                          
uint RIT;                                                   // 0x929,a  RIT A/D value
uint IFSHIFT_TX;                                               // 0x92b,c  IFSHIFT_TX A/D value
uint IFSHIFT_RX;
 	 
uchr  HZ[10];                                               // 0x92d,e,f,930,1,2,3,4,5,6  DISPLAY Digits (representing DDS)
uchr  HZ1[10];                                              // 0x937,8,9,a,b,c,d,e,f,940    Digits (representing DDS1) used for freq manipulation
    
uchr  SCAN_VALUE[10];                                       // 0x941,2,3,4,5,6,7,8,9,a input values from radio

uchr  DISP_DIGIT;										                        // 0x94b counter for updating DISPLAY and scaning buttons

uchr  BAND1;                                                // 0x94c temp register used to read/write memories to EEPROM
uchr  MEM1;												                        	// 0x94d temp register used to read/write memories to EEPROM

union			                                                   
{
    ulng LNG;       
    uint WRD[2];
} MMR;                                                      // 0x94e,f,950,1

ulng  x;                                                    // 0x952,3,4,5 temp register for power on delay
ulng  y;												                           	// 0x956,7,8,9 temp register for power on delay


uint IFCOUNTT = 0;
uint IFCOUNTR = 0;
/*=======================================================================================================*/
/*=======================================================================================================*/


  

/*=======================================================================================================*/
/*=======================================================================================================*/


#include "DDS-HW5400H0.c"                                   // Interrupt routine and Housekeeping

#pragma CODE_SEG DEFAULT

/*======================================================================================================*/
/* Main routine                                                                                         */
/*======================================================================================================*/

void main(void)
{ 
       
        _IRQCR = 0;                                         // 406c
      
        _REFDV = 7;                                         // 4072 Divides PLLCLK by (REFDV + 1) (7=24mhz) (7)
        _SYNR = 46;                                         // 4074 Multiplies PLLCLK by 2(SYNR + 1) (5=192) (46)

        for (;;)
        {
          if ( (_CRGFLG & _SCM)==0 )
          {
            if ( (_CRGFLG & _LOCK)==_LOCK ) break;          // 
          }
        }

        _CLKSEL = _PLLSEL;                                  // 4085 System clock is now PLLCLK (0X80=pll on)

        _ATDCTL2 = _ADPU;                                   // 4087 AD turned on
        _ATDCTL3 = _S4C + _S1C;                             // 4089 5 conversions per sequence
        _ATDCTL4 = _SMP1+_SMP0+_PRS2+_PRS0;                 // 4089 AD bus speed = 2mhz 10bit
        _ATDCTL5 = _MULT;                                   // 4091 right justified,multi channel
        
 
      
       													                          	// 1=output 0=input
       														
        _PORTA = 0x80;                                      // 4095 PORTA
        _DDRA = 0xff;                                       // 4099 all output (segments a thru g) 
 
        _PORTB = 0x00;                                      // 409b PORTB
        _DDRB = 0x0f;                                       // 40a0 bit 7-4=ouptut, bit3-0 input

        _PTT = 0x00;									                    	// 40a2 PORTT  (0x240) (to AD9851)
        _DDRT = 0xff;                                       // 40a7 all output  
       
        _PTJ  = 0;                                          // 40aa PORTJ   (0x268)
        _PERJ = 0xc0;                                       // 40af (192)   (0x26c)
        _DDRJ = 0;                                          // 40b2 all input (0x26a)   
        _PPSJ = 0xc0;                                       // 40b5 (0x26d)
        
        _PIFJ = 0xc0;                                       // 40b8 clear flag (0x26f)
        _PIEJ = 0x80;                                       // 40bc enable portJ int on pj7 (0x26e)
  
        _PTP  = 0x0f;                                       // 40c1 (start in 4k mode)  (0x258)
        _DDRP = 0xff;                                       // 40c4            (0x25a)
          
        _PTS = 0x02;                                        // 40c9 PORTS  (0x248)
        _DDRS = 0xfe;                                       // 40cd bit0 input (bit1-3 output)
        
      
        _PEAR = 0x10;                                       // 40d2 porte assignment
       
        _INITEE = 0x11;                                     // 40d5 eeprom starts at 1000h
        _ECLKDIV =0x16;                                     // 40d9 EEPROM clk (22)
       
           
           
/*================================================================================*/
       
         
        for (x=0;x !=0xff;x++)                                      // 40dc - 40e1   x=0x952,3,4,5
        {
            for (y=1;y < 0xff;y++)                                  // 40eb   y=0x956,7,8,9
            {
               asm nop;                                             // 40ee
            }
            
        }                                                           // 412a
   
         
         
         
        _PTT = 0;                                                   // 412c
        _PTT = 2;
        _PTT = 0;                                                   // 4134
        
        _PTT = 4;                                                   // 4138  
        
        _PTT = 0;                                                   // 413b
   
   
   
   
   
        if ( (_EE_USED != 0x1368) )                                 // 413e - 4144 check if EEPROM has good data
        {
 
            EEPROM_WRITE(&_EE_USED,0x1368);                         // 4148 - 415a   (4968 into 0x1000)
           
            _EE_MEM = &_EE_BAND;                                    // 4162    (4100 into 0x800)
           
           
            for (BAND1=0;BAND1<8;BAND1++)                           // 4165 41d3 (0x94c)   40 memories (8 *  5) = 320 bytes of eeprom
            {
                for (MEM1=0;MEM1<5;MEM1++)                          // 4168 41c9 (0x94d)
                {
                
                    MMR.LNG = FREQ[BAND1][MEM1];                    //  (0x94e,0x950)= (0x806,0x808)  
                    
                    EEPROM_WRITE(_EE_MEM,MMR.WRD[0]);               // 418b - 419b
                    _EE_MEM++;                                        
                    _EE_MEM++;                                      // 41a5
                    
                    EEPROM_WRITE(_EE_MEM,MMR.WRD[1]);               // 41ab - 41b6
                    _EE_MEM++;                                      
                    _EE_MEM++;						                          // 41c0 8 bytes per memory
                
                }
            
            }
            
            _EE_MEM = &_EE_LFREQ;                                   // 41da (0x800) = 0x1160
            
            
            
            for (MEM1=0;MEM1<8;MEM1++)                              // 41dd 
            {
                 EEPROM_WRITE(_EE_MEM,LFREQ[MEM1]);                 // 41ec - 41f8  (0x800 = 0x8de) current memory for all 8 bands (0=default)
                 _EE_MEM++;		                                      // 4202  1 word inc
                 _EE_MEM++;                                         // 4202  1 word inc
            }
         
       
        }
        else                                                       // come here at normal statup
        {
            _EE_MEM = &_EE_BAND;                                   // 4211 - 4214
            
            for (BAND1=0;BAND1<8;BAND1++)                          // 4217 - 4255 - 424f  (8 bands)
            {
                for (MEM1=0;MEM1<5;MEM1++)                         //                (5 mem per band)
                {
                     
                    MMR.WRD[0]= EEPROM_READ(_EE_MEM);              // 4220
                    _EE_MEM++;                                     // 
                    _EE_MEM++;
                    MMR.WRD[1]= EEPROM_READ(_EE_MEM);              // 4225
                    _EE_MEM++;
                    _EE_MEM++;
                
                    FREQ[BAND1][MEM1] = MMR.LNG;                   // 4242 (0x806 0x808)
                }
            
            }
            
            _EE_MEM = &_EE_LFREQ;                                  // 425c
            
            
            for (MEM1=0;MEM1<8;MEM1++)                             // 425f - 4274   (current mem using on each band)
            {
                  LFREQ[MEM1]=EEPROM_READ(_EE_MEM);                 // 426a  (0x8de)
                 _EE_MEM++;                                        //
                 _EE_MEM++;                                        // 4271
            }
        
        }
                                                                   // 427e
                                                                  
        asm  CLI;                                                  // 427e =  10 EF op codes (turn on interrupts)
                                                                   // 4280    jmp 0x4933 which makes jmp 4283 (for loop)
                                                                    
//---------------------------------------------------------------------      
      			   
        for (;;)                                                   // 4283
        {
        
        
           //------------------------------------------------------
           // turn off RECEIVER for short duration
           //------------------------------------------------------
        
         
           if ((!RECEIVER) || (RX_COUNT))                          // 4283 4290 do below if rec off or counting
           {
              
               if (!RECEIVER)                                      // 4290    (0x8fa)
               {
                    RX_COUNT=1;                                    // 4295
                    RECEIVER =1;                                   // 4298 try to turn rec back on
               }
                            
              if (RX_COUNT < 20)                                   // 429d
              {
                  _PORTA = 128;                                    // 42a7 turn off receiver
                  RX_COUNT++;                                      // 42ad
              }
              else
              {
                  _PORTA =0;                                       // 42b2 turn on rec
                  RX_COUNT=0;                                      // 42b7  (0x8fb)
              }
              
           }
           
          
       	    
           //------------------------------------------------------
           //  check AD for RIT & IF Shift control position
           //------------------------------------------------------
       	   
     	
           if (_ATDSTAT0 & _SCF)                                   // 42ba (0x86)
           { 
                                                                   // 
               AD0= (_ATDDR0)>>6;                                  // 42c6  (0x90) RIT (0x8c6)
                                                                   // 
               AD1= (_ATDDR1)>>6;                                  // 42d1  (0x92) IF Shift (0x8c8)
           
               _ATDCTL5 = _MULT;                                   // 42d6  (0x85) restart A/D
          
           }                                                       // AD ready to read
           
           
           
           IFSHIFT_TX =AD1;                                           // 4308 (0x92b) = (0x8c8)
      
           if ((IFSHIFT_TX > IF_LAST_TX+6) || (IFSHIFT_TX < IF_LAST_TX-6))     // 430b - 431a   (0x929) > (0x8ca)
           {
                IF_LAST_TX = IFSHIFT_TX;                                 // 431f 
                FREQ_CHANGE=1;                                     // 44324 (0x8e6)
               
                IFCOUNTT =150;
           }
       
       
       
             
           IFSHIFT_RX =AD0;                                           // 4308 (0x92b) = (0x8c8)
      
           if ((IFSHIFT_RX > IF_LAST_RX+6) || (IFSHIFT_RX < IF_LAST_RX-6))     // 430b - 431a   (0x929) > (0x8ca)
           {
                IF_LAST_RX = IFSHIFT_RX;                                 // 431f 
                FREQ_CHANGE=1;                                     // 44324 (0x8e6)
               
                IFCOUNTR =150;
           }
      
       
          //------------------------------------------------------
          //  zero out HZ digits if in FAST TUNE mode
          //------------------------------------------------------
 
     
          if (TUNE==14)                                            // 4327  (0x8ee)
          {
              FREQ_TO_HZ();                                        // 432e  (0x4936)  hz[] = DDS
              HZ[0]=0;                                             // (0x92d)
              HZ[1]=0;                                             // (0x92e)
              HZ[2]=0;                                             // (0x9ef)
              HZ_TO_FREQ();                                        // 4339  (0x4b46) DDS = hz[]
              FREQ_CHANGE=1;                                       // 433e
   
          }
          else
          {
              FREQ_TO_HZ();                                        // 4343 (0x4936)
          }
          
           
           
           //------------------------------------------------------
           //  check KEYPAD (11=no key, 10=ent, 0-9)
           //------------------------------------------------------
      
          
           if ((KEY==0) && (ENTER_KEY==0))                         // 4346-434b (0x8ef) (0x8f4)
           {
                  KEY = 11;                                        // 4353
  	              FREQ_CHANGE = 1;                                 // 4356
  	              OFFSET = 0;                                      // 435b  0x907 (0x905)
           }
          
           else if ((KEY==1)&& (ENTER_KEY==0))                     // 4360
           {
                  KEY = 11;                                        // 436e
                  FREQ_CHANGE = 1;                                 // 4371
                  OFFSET = 20;                                     // 4374
           }
           
           else if ((KEY==2) && (ENTER_KEY==0))                    // 437c
           {
                  KEY = 11;                                        // 4388
                  FREQ_CHANGE = 1;                                 // 438b
                  OFFSET = 30;
           }
           
           else if((KEY==3) && (ENTER_KEY==0))                     // 4393 439d
           {
                  KEY = 11;                                        // 43a2
                  FREQ_CHANGE = 1;                                 // 43a5
                  OFFSET = 40;                                     // 43a8     
  	       }
  			      			
           else if((KEY==4)&& (ENTER_KEY==0))                      // 43b9 43bd
           {
                  KEY = 11;                                        // 43c5
                  FREQ_CHANGE = 1;                                 // 43c8
                  OFFSET = -20;                                    // 43cb   65516
           }
 			                                                                     
  			   else if ((KEY==5)&& (ENTER_KEY==0))                     // 43d3 43da
           {
                  KEY = 11;                                        // 43df
                  FREQ_CHANGE = 1;                                 // 43e2
                  OFFSET = -30;                                    // 43e5  65506
           }
 
 			     else if ((KEY==6)&& (ENTER_KEY==0))                     // 43ed  43f4
           {
                  KEY = 11;                                        // 43f9
                  FREQ_CHANGE = 1;                                 // 43fc
                  OFFSET = -40;                                    // 4402   65496
           }

  			   else if((KEY==7) && (ENTER_KEY==0))                     // 4411 4418
           {
                  KEY = 11;                                        // 441d
                  FREQ_CHANGE = 1;                                 // 4420
           }
           
           else  if((KEY==8) && (ENTER_KEY==0))                    // 4428 442f
           {
                  KEY = 11;                                        // 4434
                  FREQ_CHANGE = 1;                                 // 4437
                  
                  if (RITOFF==0)
                  {
                       RITOFF = 1;                                 // 443f
                  }
                  else 
                  {
                       RITOFF = 0;                                 // 4444
                  }
           } 
           if((KEY==9) && (ENTER_KEY==0))                          // 4447  4451   (0x8f4)
           {
                  KEY = 11;                                        // 4456
                  FREQ_CHANGE = 1;                                 // 4459
                    
                  if (WIDE==0)                                      // if 2k and press 9, then 6k
                  {
                       WIDE= 2;                                     //  6k
                       _PTP = 0xF0;                                 //  lsnibble = 0
                       
                  }
                  else if (WIDE == 1)                               //  if 4k and press 9, the 2k
                  {
                       WIDE = 0;                                    //  2k
                       _PTP = 0xFF;
               
                  }
                  else if (WIDE ==2 )                               //  if 6k and press 9, then 4k
                  {
                        WIDE= 1;                                    //  4k
                        _PTP = 0x0F;                                //  msnibble = 0
                  }
                  
           }
           if ((KEY==10) && (ENTER_KEY==0))                         // 4470 (0x8ef) 447a (0x8f4) 
  			    {                                                      // START KEYPAD FREQ ENTRY
  	             _PIEJ = 0x00;                                     // DISable portJ int on pj7
  			          ENTER_KEY=7;
  			          
  			          DDS1 = DDS;                                       // (0x8d2) = (0x8ce)
  			          FREQ_TO_HZ1();                                    // 4490 (0x4a3e)
  			          KEY=11;                                           // 4495
  			    }
  			   
  			    if (ENTER_KEY)                                          // 4498
  			    {
  			        if (KEY != 11)                                      // 44a0
  			        {
  			          if (KEY==10)                                      // 44a4
  			          {
  			            KEY = HZ[ENTER_KEY];                            // 44b0 (0x8ef) = (0x92d)
  			          }
  			        
  			          HZ1[ENTER_KEY]=KEY;                               // 44bc (0x937) = (0x8ef)
  			          KEY=11;                                           // 44c0
  			          ENTER_KEY--;                                      // 44c3
  			          
  			          if (ENTER_KEY==0)                                 // 44c6
  			          {
  			             HZ1_TO_FREQ();                                 // 44c8 (0x4c09) 
  			            
  			            
  			             DDS=DDS1;                                      // 44d7 
  			             
  			             FREQ_CHANGE=1;                                 // 44dd
  			             
     		             _PIEJ = 0x80;                                  // 44e0    enable portJ int on pj7
         
  			          }
  			        }
  			        else HZ1[ENTER_KEY]=30;				                    	// 44e8 - 44ed underline character
  			    }
  			   
  			    
  	
           //------------------------------------------------------
           //  SCAN DISPLAY - KEYPAD - BUTTONS
           //------------------------------------------------------
         
            
            for (DISP_DIGIT=1;DISP_DIGIT < 10;DISP_DIGIT++)         // 44ef -   (0x94b) SCAN ALL 9 DIGITS
            {
                if (ENTER_KEY)                                      // 44f4     (0x8f4)
                {
                    _PORTA = (_PORTA & 128) | DIGIT[HZ1[DISP_DIGIT]]; //     
                }
                else
                {
                    if ((DISP_DIGIT==7) && HZ[7]==0)                 // 4504 - 450b (0x94b)
                    {
                       _PORTA = (_PORTA & 128) | DIGIT[31];          // 
                    }
                    else
                    {
                       _PORTA = (_PORTA & 128) | DIGIT[HZ[DISP_DIGIT]]; // display freq starting with 10HZ digit HZ[1]
                    }
                }
                
                _PORTB = DISP_DIGIT;	                                // 452c lower 4 bits
                
                for (y=1;y < 200;y++)			                            // 4531 (0x958) delay
                {
                   asm nop;                                           // 4538 
                }
                
                SCAN_VALUE[DISP_DIGIT] = (_PORTB >> 4 );              // 4556- (0x941) read back value
            }
           
            _PORTB = 0;   								                           	// 456e turn off last digit of DISPLAY
           
           SYMBOL2=31;	                                              // 4573  blank
      	   SYMBOL1=31;                                                // 4576 blank
      	
      	
      	   if (HZ[0])                                              // 457c
      	   {
      	      SYMBOL2=10;                                             // 4580
      	    
      	   }
      	   
      	   
           //------------------------------------------------------
           // Store BAND,MODE,KEYPAD,MEM button values
           //------------------------------------------------------
     
            BAND = ((~SCAN_VALUE[1])-240)-1;                          // 4589  (0x8e9) 0=80m, 1=40m, 15=no bank, etc
           
                       
            if (BAND==15)                                             // 458c 
            {
               RECEIVER = 0;                                          // 4590 turn rec off during band change
            } 
            
            
            MODE = SCAN_VALUE[2];                                     // 4596 (0x8ea) w,n,norm,rev = 11,12,13,14
            
            MEM  = SCAN_VALUE[3];                                     // 459c  (0x8ec) split,d<>m,d>m = 11,13,14 (15=none)
            TUNE = SCAN_VALUE[4];                                     // 45a2  (0x8ee) tune = 14
            
            KEY1 = SCAN_VALUE[5];                                     // 45a8  (0x8f0) ENT=7,       0=13, 5=14
            KEY2 = SCAN_VALUE[6];		                                  // 45ae  (0x8f1) 6  =7, 1=11, 2=13, 7=14
            KEY3 = SCAN_VALUE[7];		                                  // 45b4  (0x8f2) 8  =7, 3=11, 4=13, 9=14
            
            
            KEY4=11;										                              // 45b9  11=no key pressed
            
            if (KEY1 == 7) KEY4=10;                                   // 45bf 10=enter key    
            else if (KEY1 == 13) KEY4=0;                              // 45c9 
            else if (KEY1 == 14) KEY4=5;
            
            else if (KEY2 == 11) KEY4=1;
            else if (KEY2 == 13) KEY4=2;
            else if (KEY2 == 7)  KEY4=6;
            else if (KEY2 == 14) KEY4=7;   
            
            else if (KEY3 == 11) KEY4=3;
            else if (KEY3 == 13) KEY4=4;
            else if (KEY3 == 7)  KEY4=8;
            else if (KEY3 == 14) KEY4=9;                             // 4635
          
          
            if (KEY4 != 11)                                          // 4638 
            {
                KEY_PRESS = 1;                                       // 4641
            }
            else
            {
               KEY_PRESS = 0;                                        // 4649 (0x8f5)
               KEY_DOWN = 0;
               KEY = 11;                                             // 464c
            }                                                        
           
            
           
            if ((KEY_PRESS==1) && (KEY_DOWN==0))                     // 
            {
                KEY = KEY4;
                KEY_DOWN = 1;                                        // 4662
            }
        
  			
           //------------------------------------------------------
           //  check if BAND changed
           //------------------------------------------------------
           
       	   if (BAND != BAND_LAST)                                   // 4668  (0x8e9) (0x8c5)
       	   {
       	       RECEIVER = 0;                                        // 466d
       	       
       	       FREQ[BAND_LAST][LFREQ[BAND_LAST]]=DDS;               // 4670 - 4691  put away last memory
       	                
       	       BAND_LAST=BAND;                                      // 4698
       	       DDS = FREQ[BAND][LFREQ[BAND]];                       // 469b - 46c1 load up memory for new band (last one used on the new band)
       	       FREQ_CHANGE=1;                                       // 46c6
       	   }                                                        

           //------------------------------------------------------
           //  check if MODE changed
           //------------------------------------------------------

           if (MODE !=MODE_LAST)                                    // 46cc  (0x8ea) != (0x8eb)
           {
               FREQ_CHANGE=1;                                       // 46d3
               MODE_LAST=MODE;                                      // 46d9
           }
           
           if (MEM !=MEM_LAST)                                      // 46df (0x8ec) != (0x8ed)
           {
               FREQ_CHANGE=1;
               MEM_LAST=MEM;                                        // 
           }                                                        // 46ec
           
           
           //------------------------------------------------------
           //  check D->M button pushed
           //  check if D<->M button pushed
           //  check if SPLIT button pushed
           //------------------------------------------------------
           
           
           if (MEM==14)                                            // 46f2 Store DDS to current memory
           {
               
                SYMBOL2 = 11;                                      // 46f8
               
                if (MEMORY==0)                                     // 46fe
                {
                    MEMORY=1;                                      // 4704
                    
                    MMR.LNG = DDS;                                 // 4707-4710  (0x94e) = (0x8ce)
                    
                    _EE_MEM = &_EE_BAND;                           // 4716 
                    
                    _EE_MEM = _EE_MEM + ( (BAND*20)+(LFREQ[BAND]*4) ); // 4719-4734 memories are 8 bytes apart
                  
                    EEPROM_WRITE(_EE_MEM,MMR.WRD[0]);              // 4747 
                    _EE_MEM++;                                     //       inc 1 word or 2 bytes 
                    _EE_MEM++;                                     // 4751  inc 1 word or 2 bytes     
                    EEPROM_WRITE(_EE_MEM,MMR.WRD[1]);              // 4764  save memory in eeprom
                    
                }
               
           }
           else if (MEM==13)                                       // 4770  put away current DDS and load up next DDS from memory
           {
                SYMBOL2 =11;                                       // 4776
                
                if (MEMORY==0)                                     // 477c
                {
                    MEMORY=1;                                      // 4782
                    
                    FREQ[BAND][LFREQ[BAND]] = DDS;                 // 4785-47a6
                    
                    LFREQ[BAND]++;                                 // 47ad
                    
                    if (LFREQ[BAND] > 4) LFREQ[BAND]=0;            // 47af, 47b8
                
                    _EE_MEM = &_EE_LFREQ;                          // 47bd 
                    
                    _EE_MEM = _EE_MEM + ( BAND*2 );                // 47c0-47cb
                    
                    EEPROM_WRITE(_EE_MEM,LFREQ[BAND]);             // 47ce-47e2   save memory #
                
                    DDS = FREQ[BAND][LFREQ[BAND]];               // 47e7-480d
                    
                    FREQ_CHANGE=1;                                 // 4812
                }
                    
           }
           else if (MEM==11)                                       // 4819  SPLIT
           {
           	   if ((SPLIT==0) && (MEMORY==0))                      // 481e  (0x8f9) (0x8f8)
           	   {
           	        SPLIT=1;                                       // 4825
           	        MEMORY=1;                                      // 4828
           	        DDS_TX = DDS;                                  // 482b-4834  (0x8da) (0x8ce)
           	        
          	        
           	   }
               else if ((SPLIT==1) && (MEMORY==0))                 // 4839-4842
           	   {
           	        SPLIT=2;                                       // 4846
           	        MEMORY=1;                                      // 484a
           	        DDS_RX = DDS;                                  // 484d-4856  (0x8d6) (0x8ce)
           	  
           	   }
           	   else if ((SPLIT==2) && (MEMORY==0))                 // 485b-4865
           	   {
           	        SPLIT=0;                                       // 4867
           	        MEMORY=1;                                      // 486c
            	  
           	   }
  
           }
           else
           {
                MEMORY=0;                                          // 4871
           }
         
          
           if (SPLIT==1)                                           // 4877
           {
               SYMBOL2 = 10;                                       // 487c
           }
          
           
           if (SPLIT==2)                                           // 4884
           {
               SYMBOL2 =12;                                        // 4888
           }
           
           
           //------------------------------------------------------
           //  designate USB/LSB for each band selected
           //------------------------------------------------------
           
           
            if (MODE==11)                                         // 488e  CW-W
            {
                SYMBOL1=17;                                       // 4895
                MODE1 = 4;                                        // 4898  PTS bit2 =1
      
            } 
            else if (MODE==12)                                    // 489f  CW-N (NOW AM)
            {
            		SYMBOL1=20;                                       // 48a3   letter 0
                MODE1 = 0;                                        // 48a6 bit2,3 = 0

            }                                                               
            else if (MODE==14)                                    // 48ad   u=usb
            {
            		MODE1 = 8;                                        //  PTS bit3 =1
								SYMBOL1=18;                                       // 48af
            }  
            else                                                  //        REV
            {
                MODE1 = 12;                                       // 48b7 bit2,3 =1
								SYMBOL1=19;                                       // 48ba
            }
            
          
           //------------------------------------------------------
           //  show if IF is shifting
           //------------------------------------------------------
            
            if (IFCOUNTT)
            {
               SYMBOL1 = 21;           // -=0x04 0x11=c,0x12=u,0x13=L,0x14=0  0x1d=blank
               IFCOUNTT--; 
              
              
            }
             if (IFCOUNTR)
            {
               SYMBOL1 = 22;           // -=0x04 0x11=c,0x12=u,0x13=L,0x14=0  0x1d=blank
               IFCOUNTR--; 
              
              
            }
          
           //------------------------------------------------------
           //  check request for TX
           //------------------------------------------------------
           
            if ((_PTS & 1))                                       // 48bd   check for TX request    
            {
                SYMBOL1 = SYMBOL1 + 6;                            // 48c7   - to indicate transmit
                _PTS = _PTS & ~2;                                 // 48ca  transmit (0v out)
                RECEIVER = 0;                                     // 48ce  turn off rec when transmiting
              
                if (SPLIT==2)                                     // 48d6 
                {
                   DDS = DDS_TX;                                  // 48d8-48e1 
                  
                }
          
                RXON = 0;                                         // 48e4
                
                if (TXON==0)                                      // 48ea
                {
                    FREQ_CHANGE=1;                                // 48ee
                    TXON = 1;                                     // 48f1
                }
                
          
            }
            else
            {
                
                TXON = 0;                                         // 48f6
                
                if (RXON == 0)                                    // 48fc
                {
                  
                   FREQ_CHANGE = 1;                               // 4900
                   RXON = 1;                                      // 4903
                }
                 
                _PTS = _PTS | 2;                                  // 4906  receive (5v out)
             
                if (SPLIT==2)                                     // 490f
                {
                    DDS = DDS_RX;                                 // 4911-491a
                }
                   
                
                
               
            }
        
        
           _PTS = (_PTS & 2) | MODE1;                            // 491d-4925  update MODE output
          
         
           //------------------------------------------------------
           //  check for FREQ change update required
           //------------------------------------------------------
         
           if (FREQ_CHANGE)                                     // 4928
           {
                FREQ_CHANGE=0;                                  // 492d
                DDS_UPDATE();                                   // 4930  (0x4ccc)
               
           }
           
           
        
        } // for loop forever
           
        
} // main
        
      
 

/*======================================================================================================*/
/* Convert CHAR number to Display Digits                                                                   */
/*======================================================================================================*/
void CHAR_TO_HZ(uint C)
{
 	 
        HZ[9]=31;                                           // SET TO BLANK
  	    HZ[8]=31;
  	    
        HZ[7]=31;
        
        HZ[6]= C/1000;
        C = C % 1000;
        
        HZ[5]= C / 100;
        C = C % 100; 
        
        HZ[4]= C / 10;
        C = C % 10; 

        HZ[3]= C; 
       
        HZ[2]=31;    
        HZ[1]=31;
        
        HZ[0]=31;
       
 }
 

/*======================================================================================================*/
/* Convert DDS freq to Display Digits                                                                   */
/* INPUT = DDS                                                                                          */
/* OUTPUT = HZ[] decimal digits                                                                         */
/*======================================================================================================*/
void FREQ_TO_HZ(void)                                              // 4936
{
 	    static ulng DDS_TEMP;                                        // 0x909,a,b,c
 	   
        DDS_TEMP = DDS;                                            // 4936-493f  (0x909)
 
        HZ[9]= SYMBOL2;                                            // 4945
  	    HZ[8]= SYMBOL1;                                            // 494b
            
        HZ[7] = DDS_TEMP / 10000000;                               // 494e-4960  (0x5244)
        DDS_TEMP = DDS_TEMP % 10000000;
        
        HZ[6]= DDS_TEMP / 1000000;                                // 4987
        DDS_TEMP = DDS_TEMP % 1000000;
         
        HZ[5]= DDS_TEMP / 100000;                                 // 49ad
        DDS_TEMP = DDS_TEMP % 100000;                             // 49c0
        
        HZ[4]= DDS_TEMP / 10000;                                  // 49c5
        DDS_TEMP = DDS_TEMP % 10000; 

        HZ[3]= DDS_TEMP / 1000;     // 
        DDS_TEMP = DDS_TEMP % 1000; 
        
        HZ[2]= DDS_TEMP / 100;
        DDS_TEMP = DDS_TEMP % 100; 
        
        HZ[1]= DDS_TEMP / 10;
        DDS_TEMP = DDS_TEMP % 10; 

        HZ[0]= DDS_TEMP;                                           // 4a3b
        
}                                                                  // 4a3d
 

/*======================================================================================================*/
/* Convert DDS1 freq to Display Digits                                                                   */
/* INPUT = DDS1                                                                                          */
/* OUTPUT = HZ1[] decimal digits                                                                         */
/*======================================================================================================*/
void FREQ_TO_HZ1(void)                                             // 4a3e
{
 	    static ulng DDS_TEMP;                                       // 0x90d,e,f,0x910
 	   
        DDS_TEMP = DDS1;
     
        HZ1[9]= SYMBOL2;                                    //
  	    HZ1[8]= SYMBOL1;
        
        HZ1[7] = DDS_TEMP / 10000000;
        DDS_TEMP = DDS_TEMP % 10000000;
        
        HZ1[6]= DDS_TEMP / 1000000;
        DDS_TEMP = DDS_TEMP % 1000000;
         
        HZ1[5]= DDS_TEMP / 100000;
        DDS_TEMP = DDS_TEMP % 100000; 
        
        HZ1[4]= DDS_TEMP / 10000;
        DDS_TEMP = DDS_TEMP % 10000; 

        HZ1[3]= DDS_TEMP / 1000;
        DDS_TEMP = DDS_TEMP % 1000; 
        
        HZ1[2]= DDS_TEMP / 100;
        DDS_TEMP = DDS_TEMP % 100; 
        
        HZ1[1]= DDS_TEMP / 10;
        DDS_TEMP = DDS_TEMP % 10; 

        HZ1[0]= DDS_TEMP;
        
}                                                                 // 4b45
  
 
/*======================================================================================================*/
/* Convert Display Digits to DDS freq                                                                   */
/* INPUT = HZ[] decimal digits                                                                          */
/* OUTPUT = DDS freq.                                                                                   */
/*======================================================================================================*/
void HZ_TO_FREQ(void)                                            // 4b46
{
  		DDS = ((ulng)HZ[7] * (ulng)10000000)+((ulng)HZ[6] * (ulng)1000000)+
  		((ulng)HZ[5] * (ulng)100000)+ ((ulng)HZ[4] * (ulng)10000)+ 
  		((ulng)HZ[3] * (ulng)1000)+	((ulng)HZ[2] * (ulng)100)+
  		((ulng)HZ[1] * 10) + ((ulng)HZ[0]);        
}                                                               // 4c08
 
/*======================================================================================================*/
/* Convert Display Digits to DDS freq                                                                   */
/* INPUT = HZ1[] decimal digits                                                                          */
/* OUTPUT = DDS1 freq.                                                                                   */
/*======================================================================================================*/
void HZ1_TO_FREQ(void)                                           //4c09
{
  		DDS1 = ((ulng)HZ1[7] * (ulng)10000000)+((ulng)HZ1[6] * (ulng)1000000)+
  		((ulng)HZ1[5] * (ulng)100000)+ ((ulng)HZ1[4] * (ulng)10000)+ 
  		((ulng)HZ1[3] * (ulng)1000)+	((ulng)HZ1[2] * (ulng)100)+
  		((ulng)HZ1[1] * 10) + ((ulng)HZ1[0]);        
}                                                               // 4ccb


  
 
/*======================================================================================================*/
/* Send DDS freq to AD9850 chip                                                                         */
/* Convert Freq. to DDS (with 100 mhz ref)                                                              */
// PT2 =  4   DDS freq update (pulse 0-1-0)
// PT1 =  2   DDS serial clk  (pulse 0-1-0)
// PT0 =  1   DDS serial data (40 bit= 32data & 8bit control)
/*======================================================================================================*/
void DDS_UPDATE(void)                                       // 4ccc
{
   	
      static double FREQ_F;                                 // 0x911,2,3,4  RF freq value
      static ulng FREQ_I;                                   // 0x915,6,7,8  IF freq value
      static ulng TEMP;	                                    // 0x919,a,b,c  temp counter
      static ulng RIT_VALUE;                                // 0x91d,e,f,920  final RIT freq change
      static ulng IF_VALUE_TX;                                 // 0x921,2,3,4 
      static ulng IF_VALUE_RX;
      static ulng DDS_TEMP;                                 // 0x925,6,7,8  chnage in DDS caused by RIT
     
     
     
      DDS_TEMP = DDS;                                       // 4ccc-4cd5  (0x925)
     
      if (!(_PTS & 1))                                      // 4cd8  Do below if RX    
      { 
       
          
         if (IFSHIFT_RX <= IF_CENTER_RX)                            // 4d55-4d5b  (0x92b) <= (0x4068)
         {
            
             IF_VALUE_RX = IF_CENTER_RX - IFSHIFT_RX;                  // 4d5d-4d68
             DDS_TEMP = DDS_TEMP - IF_VALUE_RX;                  // 4d6b-4d7a
         }
         else
         {
             IF_VALUE_RX = IFSHIFT_RX - IF_CENTER_RX;                  // 4d7f-4d87
             DDS_TEMP = DDS_TEMP + IF_VALUE_RX;                  // 4d8a-4d9c
         }
       
           
            
      }  // RX only                                 // 
      else
      {
                 
         if (IFSHIFT_TX <= IF_CENTER_TX)                            // 4d55-4d5b  (0x92b) <= (0x4068)
         {
            
             IF_VALUE_TX = IF_CENTER_TX - IFSHIFT_TX;                  // 4d5d-4d68
             DDS_TEMP = DDS_TEMP - IF_VALUE_TX;                  // 4d6b-4d7a
         }
         else
         {
             IF_VALUE_TX = IFSHIFT_TX - IF_CENTER_TX;                  // 4d7f-4d87
             DDS_TEMP = DDS_TEMP + IF_VALUE_TX;                  // 4d8a-4d9c
         }
        
      }  // TX only

//----------------------------------------------------------------------------------               
// Select Filter and MODE Values
//----------------------------------------------------------------------------------               


      if (MODE1==8)					                                // 4d9f  (0x8f7) add the correct IF freq. depending on MODE   
      {
        
          if (WIDE==1)                                         // 4da9
	        {
	          if ((_PTS & 1)) FREQ_I = DDS_TEMP + USB4_IF; 
	          else  FREQ_I = DDS_TEMP + USB4_IFR;                  // 4dab-4dba (0x915) = (0x925) +(0x4058 U 4k)
	        }
	        else if (WIDE==0)
	        {
	          if ((_PTS & 1)) FREQ_I = DDS_TEMP + USB_IF; 
	          else  FREQ_I = DDS_TEMP + USB_IFR;                  // 4dab-4dba (0x915) = (0x925) +(0x4058 U 4k)
	        }
	        else if (WIDE==2)
	        {
	          if ((_PTS & 1)) FREQ_I = DDS_TEMP + USB6_IF; 
	          else  FREQ_I = DDS_TEMP + USB6_IFR;                  // 4dab-4dba (0x915) = (0x925) +(0x4058 U 4k)
	        }
  
        
      }
      else if (MODE1==12)                                   // 4dd3
      {
          if (WIDE==1)                                         // 4dd5
	        {
	          if ((_PTS & 1)) FREQ_I = DDS_TEMP + LSB4_IF; 
	          else  FREQ_I = DDS_TEMP + LSB4_IFR;                  // 4dab-4dba (0x915) = (0x925) +(0x4058 U 4k)
	        }
	        else if (WIDE==0)
	        {
	          if ((_PTS & 1)) FREQ_I = DDS_TEMP + LSB_IF; 
	          else  FREQ_I = DDS_TEMP + LSB_IFR;                  // 4dab-4dba (0x915) = (0x925) +(0x4058 U 4k)
	        }
	        else 
	        {
	          if ((_PTS & 1)) FREQ_I = DDS_TEMP + LSB6_IF; 
	          else  FREQ_I = DDS_TEMP + LSB6_IFR;                  // 4dab-4dba (0x915) = (0x925) +(0x4058 U 4k)
	        }
	  
	       
      }
      else if (MODE1==4)                                    // 4e04
      {
          if (WIDE==1)                                         // 4e06
	        {
	            FREQ_I = DDS_TEMP + CW4_IF;                   // 4e0d-4e1c    +(0x4060 C 4k)
	        }
	        else if (WIDE==0)
	        {
	            FREQ_I = DDS_TEMP + CW_IF;                    // 4e21-4e30    +(0x4054 C 2.4k)
	        }
	        else if (WIDE==2)
	        {
	            FREQ_I = DDS_TEMP + CW6_IF;                   //   6.0k
	        }

	       
      } 
      else                                                  // 4e35
      {
         FREQ_I = DDS_TEMP + AM_IF;                         // 4e35-4e47       +(0x4048 A)
      }
        
        
         
 	     
//----------------------------------------------------------------------------------               
//    update DDS chip
//----------------------------------------------------------------------------------               
 	    
      
                      
      FREQ_F = ((double)FREQ_I * FREQ_BITS) / FREQ_CLOCK;	 //  4e4a-4e6a  serial phase = (freq * 2^32) / clock
      
	    FREQ_I = FREQ_F;                                     // 4e6c-4e78
  			
      for (TEMP=1;TEMP!=0;TEMP=TEMP<<1)                    // 4e7b-4e82, 4eb9-4ecd
      {
           if ((FREQ_I & TEMP))                            // 4e85-4ea5
           {
              _PTT = 1;                                    // 4ea9
           }
           else
           {
             _PTT = 0;                                     // 4eae
           }
  				 
          _PTT = _PTT | 2;
          _PTT = _PTT & ~2;                                // 4eb5 DDS serial CLK
      }   // 4ecd
  
                                                           
          _PTT = 1;                                        // 4ed1 THIS IS FOR AD9851 CHIP (ENGAGE X6 CLK MULT)
           
          _PTT = _PTT | 2;                                 // 4ed4
          _PTT = _PTT & ~2; 
          
         
         
         
         
          
      for (TEMP=1;TEMP <=7;TEMP++)                          // 4edc  loop unrolled
      {
          _PTT = 0;                                         // control and phase = 0
          _PTT = 2;                                         // ;CLOCK
          _PTT = 0; 
      }
    
      
      _PTT = 4;                                             // 4f28
      _PTT = 0;                                             // 4f2b   DDS freq update
      
      
     
      
    
} // DDS_UPDATE
 
 
 
 
 

