/*  Darrin Kohn 08/26/2002  */
/*  Register list MC9S12DP256 */




/*------------------------------------------------------------------------------------*/
/*Core module       (base + $0000-$0033)                                              */
/*------------------------------------------------------------------------------------*/
#define _PORTA      (*((volatile uchar*) (0x0000)))  // Port A (default=$00)
#define _DDRA       (*((volatile uchar*) (0x0002)))  // Data Direction A (default=$00) 1=out 0=in
#define _PA7         128
#define _PA6         64
#define _PA5         32
#define _PA4         16
#define _PA3         8
#define _PA2         4
#define _PA1         2
#define _PA0         1

#define _PORTB      (*((volatile uchar*) (0x0001)))  // Port B (default=$00)
#define _DDRB       (*((volatile uchar*) (0x0003)))  // Data Direction B  (default=$00) 1=out 0=in
#define _PB7         128
#define _PB6         64
#define _PB5         32
#define _PB4         16
#define _PB3         8
#define _PB2         4
#define _PB1         2
#define _PB0         1

#define RESRV1      (*((volatile uchar*) (0x0004)))  // Reserved (not used)
#define RESRV2      (*((volatile uchar*) (0x0004)))  // Reserved (not used)
#define RESRV3      (*((volatile uchar*) (0x0004)))  // Reserved (not used)
#define RESRV4      (*((volatile uchar*) (0x0004)))  // Reserved (not used)

#define _PORTE      (*((volatile uchar*) (0x0008)))  // Port E (default=$00)
#define _DDRE       (*((volatile uchar*) (0x0009)))  // Data Direction E  (default=$00) 1=out 0=in
#define _PE7         128
#define _PE6         64
#define _PE5         32
#define _PE4         16
#define _PE3         8
#define _PE2         4
#define _PE1         2                               // bit1 is INPUT only
#define _PE0         1                               // bit0 is INPUT only

#define _PEAR       (*((volatile uchar*) (0x000A)))  // Port E PIN assignment  (default=depends on _MODE)
#define _NOACCE      128                             // 0=bit7 i/o, 1=noacce pin
#define _PIPOE       32                              // 0=bit5 i/o, 1=pipoe pin
#define _NECLK       16                              // 0=bit4 i/o, 1=eclk pin (free run if _EBICTL _ESTR=0)
#define _LSTRE       8                               // 0=bit3 i/o, 1=lstrb pin
#define _RDWE        4                               // 0=bit2 i/o, 1=r/w pin

#define _MODE       (*((volatile uchar*) (0x000B)))  // Mode reg (default=depends on bit values at power up)
#define _MODC        128                             // mode selection
#define _MODB        64                              // mode selection
#define _MODA        32                              // mode selection
#define _IVIS        8                               // 1=internal visiblity from outside
#define _EMK         2                               // 0= Port K i/o, 1= external address pins
#define _EME         1                               // always 0 (use _PEAR reg)

#define _PUCR       (*((volatile uchar*) (0x000C)))  // Pullup control reg (default=$90)
#define _PUPKE       128                             // 1=enable pullup for PORT K
#define _PUPEE       16                              // 1=enable pullup for PORT E (bits7,4,3,2,1,0)
#define _PUPBE       2                               // 1=enable pullup for PORT B
#define _PUPAE       1                               // 1=enable pullup for PORT A

#define _RDRIV      (*((volatile uchar*) (0x000D)))  // Reduced drive reg (for low power and RFI) (default=$00)
#define _RDPK        128                             // 1=enable reduced drive for PORT K
#define _RDPE        16                              // 1=enable reduced drive for PORT E (bits7,6,5,4,3,2)
#define _RDPB        2                               // 1=enable reduced drive for PORT B
#define _RDPA        1                               // 1=enable reduced drive for PORT A

#define _EBICTL     (*((volatile uchar*) (0x000E)))  // External bus interface control reg (default=$01)
#define _ESTR        1                               // 0=eclk is free running (never stretches), 1=stretches

#define RESRV5      (*((volatile uchar*) (0x000F)))  // Reserved (not used)

#define _INITRM     (*((volatile uchar*) (0x0010)))  // Init int ram pos reg (default=$09)
#define _RAM15       128                             // upper 5 bits of base ram address
#define _RAM14       64                              // default = $0800
#define _RAM13       32                              //
#define _RAM12       16                              //
#define _RAM11       8                               //
#define _RAMHAL      1                               // 0=Aligns the ram to $0000 of mapable space, 1= $ffff

#define _INITRG     (*((volatile uchar*) (0x0011)))  // Init int reg pos reg (default=$00)
#define _REG15        128                            // always = 0
#define _REG14       64                              // 4 bits of base reg address, default=$0000
#define _REG13       32                              //
#define _REG12       16                              //
#define _REG11       8                               //

#define _INITEE     (*((volatile uchar*) (0x0012)))  // Init int EEprom pos reg (default=$01)
#define _EEG15        128                            // 5 bits of base EEPROM address, default=$
#define _EEG14       64                              //
#define _EEG13       32                              //
#define _EEG12       16                              //
#define _EEG11       8                               //
#define _EEON        1                               // 0=eeprom off, 1=eeprom on

#define _MISC       (*((volatile uchar*) (0x0013)))  // Misc system control reg (default=$00)
#define _EXSTR1      8                               // eclk stretch external address default=3 clocks
#define _EXSTR0      4                               //
#define _ROMHM       2                               // 0=eeprom on in lower half of memory
#define _ROMON       1                               // 0=eeprom off 1=on

#define RESRV6      (*((volatile uchar*) (0x0014)))  // Reserved (not used)
#define RESRV7      (*((volatile uchar*) (0x0015)))  // Int test control reg
#define RESRV8      (*((volatile uchar*) (0x0016)))  // Int test control reg
#define RESRV9      (*((volatile uchar*) (0x0017)))  // Reserved (not used)
#define RESRVA      (*((volatile uchar*) (0x0018)))  // Reserved (not used)
#define RESRVB      (*((volatile uchar*) (0x0019)))  // Reserved (not used)
#define RESRVC      (*((volatile uchar*) (0x001A)))  // Reserved (not used)
#define RESRVD      (*((volatile uchar*) (0x001B)))  // Reserved (not used)
#define RESRVE      (*((volatile uchar*) (0x001C)))  // mem size reg0 (read only)
#define RESRVF      (*((volatile uchar*) (0x001D)))  // mem size reg1 (read only)

#define _IRQCR      (*((volatile uchar*) (0x001E)))  // IRQ control reg (default=$40)
#define _IRQE        128                             // 0=low level recognition, 1=falling edge
#define _IRQEN       64                              // 0=IRQ pin turned off, 1=IRQ pin turned on

#define _HPRIO      (*((volatile uchar*) (0x001F)))  // Highet prio I int reg (default=$f2)
#define _PSEL7        128                            //
#define _PSEL6       64                              //
#define _PSEL5       32                              //
#define _PSEL4       16                              // low byte of vector address is highest prio
#define _PSEL3       8                               // default=$fff2
#define _PSEL2       4                               //
#define _PSEL1       2                               //

#define RESRV10     (*((volatile uchar*) (0x0020)))  // Reserved (not used)
#define RESRV11     (*((volatile uchar*) (0x0021)))  // Reserved (not used)
#define RESRV12     (*((volatile uchar*) (0x0022)))  // Reserved (not used)
#define RESRV13     (*((volatile uchar*) (0x0023)))  // Reserved (not used)
#define RESRV14     (*((volatile uchar*) (0x0024)))  // Reserved (not used)
#define RESRV15     (*((volatile uchar*) (0x0025)))  // Reserved (not used)
#define RESRV16     (*((volatile uchar*) (0x0026)))  // Reserved (not used)
#define RESRV17     (*((volatile uchar*) (0x0027)))  // Reserved (not used)

#define _BKPCT0     (*((volatile uchar*) (0x0028)))  // Breakpoint cont reg0 (default=$00)
#define _BKEN         128                            // 0=off 1=on
#define _BKFULL      64                              // 0=dual mode, 1=full
#define _BKDBM       32                              // 0=go to soft int, 1=go to BDM
#define _BKTAG       16                              // 0=on match, break at next ins., 1=if ins executed

#define _BKPCT1     (*((volatile uchar*) (0x0029)))  // Breakpoint cont reg1 (default=$00)
#define _BK0MBH      128                             // dual/full mode mask address range break 0
#define _BK0MBL      64                              //
#define _BK1MBH      32                              // dual mode mask address range break 1
#define _BK1MBL      16                              //
#define _BK0RWE      8                               // full mode byte/word address compare
#define _BK0RW       4                               //
#define _BK1RWE      2                               //
#define _BK1RW       1                               //

#define _BKP0X      (*((volatile uchar*) (0x002A)))  // Breakpoint 0 expansion address reg (default=$00)
#define _BK0V5       32                              //
#define _BK0V4       16                              //
#define _BK0V3       8                               // contain data to match expansion address
#define _BK0V2       4                               //
#define _BK0V1       2                               //
#define _BK0V0       1                               //

#define _BKP0H      (*((volatile uchar*) (0x002B)))  // Breakpoint 0 High address reg (default=$00)
#define _BKP0L      (*((volatile uchar*) (0x002C)))  // Breakpoint 0 Low address reg (default=$00)

#define _BKP1X      (*((volatile uchar*) (0x002D)))  // Breakpoint 1 expansion address reg (default=$00)
#define _BK1V5       32                              // 
#define _BK1V4       16                              //
#define _BK1V3       8                               // contain data to match expansion address
#define _BK1V2       4                               //
#define _BK1V1       2                               // 
#define _BK1V0       1                               // 

#define _BKP1H      (*((volatile uchar*) (0x002E)))  // Breakpoint 1 High address reg (default=$00)
#define _BKP1L      (*((volatile uchar*) (0x002F)))  // Breakpoint 1 Low address reg (default=$00)

#define _PPAGE      (*((volatile uchar*) (0x0030)))  // Program page index reg (default=$00)
#define _PIX5        32                              //
#define _PIX4        16                              // UP TO PAGE63 FOR 1MEG
#define _PIX3        8                               // 
#define _PIX2        4                               //
#define _PIX1        2                               // 
#define _PIX0        1                               // 

#define RESRV18     (*((volatile uchar*) (0x0031)))  // Reserved (not used)

#define _PORTK      (*((volatile uchar*) (0x0032)))  // Port K reg (default=$00)
#define _DDRK       (*((volatile uchar*) (0x0033)))  // Data Direction K (default=$00) 1=out 0=in
#define _ECS         128                             // emulation chip select
#define _XCS         64                              // external chip select (not brought out of chip)
#define _XAB19       32                              // 6 expanded address bits
#define _XAB18       16                              //
#define _XAB17       8                               // 
#define _XAB16       4                               //
#define _XAB15       2                               // 
#define _XAB14       1                               // 

#define _PK7         128                             // 8 general i/o bits
#define _PK5         32
#define _PK4         16
#define _PK3         8
#define _PK2         4
#define _PK1         2
#define _PK0         1


/*------------------------------------------------------------------------------------*/
/* Clock and         Reset Generator module (base + $0034-$003F)                      */
/*------------------------------------------------------------------------------------*/
#define _SYNR       (*((volatile uchar*) (0x0034)))  // Synthesizer reg (default=$00)
#define _SYN5        32                              //
#define _SYN4        16                              // pllclk = 2*oscclk*((syn + 1)/(refdv +1))
#define _SYN3        8                               // 
#define _SYN2        4                               //
#define _SYN1        2                               // 
#define _SYN0        1                               // 

#define _REFDV      (*((volatile uchar*) (0x0035)))  // Ref divider  reg (default=$00)
#define _SYN5        32                              //
#define _SYN4        16                              // pllclk = 2*oscclk*((syn + 1)/(refdv +1))
#define _SYN3        8                               // 
#define _SYN2        4                               //
#define _SYN1        2                               // 
#define _SYN0        1                               //

#define RESRV19     (*((volatile uchar*) (0x0036)))  // Reserved (not used)

#define _CRGFLG     (*((volatile uchar*) (0x0037)))  // Flags reg (default=$40)
#define _RTIF        128                             // clear by writing 1: 1=rti has occured
#define _PORF        64                              // 1=power on reset occured
#define _LOCKIF      16                              // 1=pll lock has changed
#define _LOCK        8                               // 1=pll ok, 0=pll bad  (read only)
#define _TRACK       4                               // 1=pll tracking, 0=pll acqusition  (read only)
#define _SCMIF       2                               // 1=scm bit changed, 0=no change
#define _SCM         1                               // 1=self clock mode, 0=normal  (read only)

#define _CRGINT     (*((volatile uchar*) (0x0038)))  // Int enable reg (default=$00)
#define _RTIE        128                             // 1=rti enabled, 0=disabled
#define _LOCKIE      16                              // 1=lockif enabled
#define _SCMIE       2                               // 1=scmif enabled

#define _CLKSEL     (*((volatile uchar*) (0x0039)))  // Clock select reg (default=$00)
#define _PLLSEL      128                             // 1=system clock is pllclk, 0=system is oscclk
#define _PSTP        64                              // 1=osc runs in stop mode,0=osc stops
#define _SYSWAI      32                              // 1=system clock stops in wait mode
#define _ROAWAI      16                              // 1=reduced amplitude osc in wait mode
#define _PLLWAI      8                               // 1= pll stops in wait mode
#define _CWAI        4                               // 1=core clk stops in wait mode
#define _RTIWAI      2                               // 1=rti stops and inits rti dividers in wait mode
#define _COPWAI      1                               // 1=cop stop and inits cop dividers in wait mode

#define _PLLCTL     (*((volatile uchar*) (0x003A)))  // PLL control reg (default=$F1)
#define _CME         128                             // 1=clock monitor on
#define _PLLON       64                              // 1=pll is on (if AUTO=1, pll will lock)
#define _AUTO        32                              // 1=auto on, ACQ has no effect
#define _ACQ         16                              // 1=high bandwith filter, 0=low
#define _PRE         4                               // 1=rti runs in pseudo stop mode
#define _PCE         2                               // 1=cop runs in pseudo stop mode
#define _SCME        1                               // 1=crystal clock failure causes clock monitor reset

#define _RTICTL     (*((volatile uchar*) (0x003B)))  // RTI control reg (default=$00)
#define _RTR6        64                              // 3 RTI prescale bits
#define _RTR5        32                              // 
#define _RTR4        16                              // 
#define _RTR3        8                               // 4 RTI modulus counter bits (see tables)
#define _RTR2        4                               // 
#define _RTR1        2                               // the source clock for RTI is oscclk
#define _RTR0        1                               // 

#define _COPCTL     (*((volatile uchar*) (0x003C)))  // COP control reg (default=$00)
#define _WCOP        128                             // 1=window type COP usage, 0=normal COP
#define _RSBCK       64                              // 1=stops COP and RTI when in BDM mode, 0=COP and RTI keep running in BDM
#define _CR2         4                               // 
#define _CR1         2                               // 0=disabled COP 8=2^24 oscclk cycles
#define _CR0         1                               // 

#define RESRV1A     (*((volatile uchar*) (0x003D)))  // Reserved (not used)
#define RESRV1B     (*((volatile uchar*) (0x003E)))  // Reserved (not used)

#define _ARMCOP     (*((volatile uchar*) (0x003F)))  // COP timer Arm/Reset reg (default=$00)


/*------------------------------------------------------------------------------------*/
/* Enhanced          Capture - Timer Module (base + $0040-$007F)                      */
/*------------------------------------------------------------------------------------*/
#define _TIOS       (*((volatile uchar*) (0x0040)))  // Timer input capture/output compare reg (default=$00)
#define _IOS7        128                             //
#define _IOS6        64                              //
#define _IOS5        32                              //
#define _IOS4        16                              // 
#define _IOS3        8                               // 1=output compare channel, 0=input capture channel
#define _IOS2        4                               //
#define _IOS1        2                               // 
#define _IOS0        1                               // 


#define _CFORC      (*((volatile uchar*) (0x0041)))  // Timer compare force reg (default=$00) (write only)
#define _FOC7        128                             //
#define _FOC6        64                              //
#define _FOC5        32                              //
#define _FOC4        16                              // 
#define _FOC3        8                               // 1= force channel set for compare to occur, but flag is not set
#define _FOC2        4                               //
#define _FOC1        2                               // 
#define _FOC0        1                               // 


#define _OC7M       (*((volatile uchar*) (0x0042)))  // Output compare 7 mask reg (default=$00)
#define _OC7M7       128                             //
#define _OC7M6       64                              //
#define _OC7M5       32                              //
#define _OC7M4       16                              // 
#define _OC7M3       8                               // 1= turn on channel for output that TIOS has set to 1 as well
#define _OC7M2       4                               //
#define _OC7M1       2                               // 
#define _OC7M0       1                               // 

#define _OC7D       (*((volatile uchar*) (0x0043)))  // Output compare 7 data reg (default=$00)
#define _OC7D7       128                             //
#define _OC7D6       64                              //
#define _OC7D5       32                              //
#define _OC7D4       16                              // 
#define _OC7D3       8                               // 
#define _OC7D2       4                               //
#define _OC7D1       2                               // 
#define _OC7D0       1                               // 

#define _TCNT       (*((volatile uint*) (0x0044)))   // 16bit up counter reg (default=$0000) (read only)

#define _TSCR1      (*((volatile uchar*) (0x0046)))  // Timer system control reg1 (default=$00)
#define _TEN         128                             // 1=normal, 0=timer and counter off (low power)
#define _TSWAI       64                              // 1=disable timer module in wait mode, 0=normal
#define _TSFRZ       32                              // 1=disable timer module in freeze mode, 0=mormal
#define _TFFCA       16                              // 1=fast flag clearing, 0=normal

#define _TTOV       (*((volatile uchar*) (0x0047)))  // Timer toggle on overflow reg (default=$00)
#define _TOV7        128                             //
#define _TOV6        64                              //
#define _TOV5        32                              //
#define _TOV4        16                              // 1=toggles output compare pin on overflow 
#define _TOV3        8                               // 
#define _TOV2        4                               //
#define _TOV1        2                               // 
#define _TOV0        1                               // 

#define _TCTL1      (*((volatile uchar*) (0x0048)))  // Timer control reg1 (default=$00)
#define _OM7         128                             // 0=timer disconnect from output pin
#define _OL7         64                              // 1=toggle output line
#define _OM6         32                              // 2=clear output line to 0
#define _OL6         16                              // 3=set output line to 1
#define _OM5         8                               // 
#define _OL5         4                               //
#define _OM4         2                               // 
#define _OL4         1                               // 

#define _TCTL2      (*((volatile uchar*) (0x0049)))  // Timer control reg2 (default=$00)
#define _OM3         128                             // 0=timer disconnect from output pin
#define _OL3         64                              // 1=toggle output line
#define _OM2         32                              // 2=clear output line to 0
#define _OL2         16                              // 3=set output line to 1
#define _OM1         8                               // 
#define _OL1         4                               //
#define _OM0         2                               // 
#define _OL0         1                               // 

#define _TCTL3      (*((volatile uchar*) (0x004A)))  // Timer control reg3 (default=$00)
#define _EDG7B       128                             // 0=capture disabled
#define _EDG7A       64                              // 1=capture on rising edge only
#define _EDG6B       32                              // 2=capture on falling edge
#define _EDG6A       16                              // 3=any edge
#define _EDG5B       8                               // 
#define _EDG5A       4                               //
#define _EDG4B       2                               // 
#define _EDG4A       1                               // 

#define _TCTL4      (*((volatile uchar*) (0x004B)))  // Timer control reg4 (default=$00)
#define _EDG3B       128                             // 0=capture disabled
#define _EDG3A       64                              // 1=capture on rising edge only
#define _EDG2B       32                              // 2=capture on falling edge
#define _EDG2A       16                              // 3=any edge
#define _EDG1B       8                               // 
#define _EDG1A       4                               //
#define _EDG0B       2                               // 
#define _EDG0A       1                               // 

#define _ETIE       (*((volatile uchar*) (0x004C)))  // Timer int. enable reg (default=$00)
#define _C7I         128                             // 
#define _C6I         64                              // 
#define _C5I         32                              // 
#define _C4I         16                              // 1=TFLG1 bits can cause a Hardware int.
#define _C3I         8                               // 
#define _C2I         4                               //
#define _C1I         2                               // 
#define _C0I         1                               // 


#define _TSCR2      (*((volatile uchar*) (0x004D)))  // Timer system control reg2 (default=$00)
#define _TOI         128                             // 1=hardware int. for TOF flag
#define _TCRE        8                               // 1=counter reset by succesfull output compare 7,0=counter if free run
#define _PR2         4                               // 
#define _PR1         2                               // 0=Prescale of 1, 7=prescale of 128
#define _PR0         1                               // 

#define _TFLG1      (*((volatile uchar*) (0x004E)))  // Timer int. flag reg1 (default=$00)
#define _C7F         128                             // 
#define _C6F         64                              // 
#define _C5F         32                              // 
#define _C4F         16                              // 1=FLAG IS SET
#define _C3F         8                               // TO CLEAR WRITE A 1 TO CORRESPONDING BIT
#define _C2F         4                               //
#define _C1F         2                               // 
#define _C0F         1                               // 

#define _TFLG2      (*((volatile uchar*) (0x004F)))  // Timer int. flag reg2 (default=$00)
#define _TOF         128                             // 1=timer overflow flag, write 1 to clear flag

#define _TC0        (*((volatile uint*) (0x0050)))   // 16bit input capture/output compare setpoint reg (default=$0000) 
#define _TC1        (*((volatile uint*) (0x0052)))   // 16bit input capture/output compare setpoint reg (default=$0000) 
#define _TC2        (*((volatile uint*) (0x0054)))   // 16bit input capture/output compare setpoint reg (default=$0000) 
#define _TC3        (*((volatile uint*) (0x0056)))   // 16bit input capture/output compare setpoint reg (default=$0000) 
#define _TC4        (*((volatile uint*) (0x0058)))   // 16bit input capture/output compare setpoint reg (default=$0000) 
#define _TC5        (*((volatile uint*) (0x005A)))   // 16bit input capture/output compare setpoint reg (default=$0000) 
#define _TC6        (*((volatile uint*) (0x005C)))   // 16bit input capture/output compare setpoint reg (default=$0000) 
#define _TC7        (*((volatile uint*) (0x005E)))   // 16bit input capture/output compare setpoint reg (default=$0000) 

#define _PACTL      (*((volatile uchar*) (0x0060)))  // Pulse acc A control reg (default=$00)
#define _PAEN        64                              // 1=enable 16bit pulse accumulator
#define _PAMOD       32                              // when PAEN=1 then: 0=event counter mode, 1=gated time acculation mode 
#define _PEDGE       16                              // when PAMOD=0 then 0=falling edge on PT7, 1=Rising edge
#define _CLK1        8                               // when PAMOD=1 then 0=PT7 pin high enables bus clock/64 to pulse acc and falling edge set PA1F
#define _CLK0        4                               // 0=use timer prescaler clock as counter clock, 1=PACLK is input to counter clock,2=PACLK/256,2=PACLK/65536
#define _PAOVI       2                               // 1= int. request if PAOVF is set
#define _PAI         1                               // 0=int. inhibited, 1=int request if PAIF is set

#define _PAFLG      (*((volatile uchar*) (0x0061)))  // Pulse acc A flag reg (default=$00)
#define _PAOVF       2                               // 1=when pulse acc A overflows from ffff to 0000 (write to PAFLG to clear)
#define _PAIF        1                               // 1=when the selected edge on PT7 is detected or trailing edge in event mode

#define _PACN32     (*((volatile uint*) (0x0062)))  // Pulse acc A count reg (default=$00)
#define _PACN10     (*((volatile uint*) (0x0064)))  // Pulse acc B count reg (default=$00)


#define _PACN3      (*((volatile uchar*) (0x0062)))  // Pulse acc A count reg (default=$00)
#define _PACN1      (*((volatile uchar*) (0x0064)))  // Pulse acc B count reg (default=$00)
#define _PACNT15     128                             // 
#define _PACNT14     64                              // 
#define _PACNT13     32                              // 
#define _PACNT12     16                              // 8 bit or high byte of 16 bit counter
#define _PACNT11     8                               // 
#define _PACNT10     4                               //
#define _PACNT9       2                              // 
#define _PACNT8       1                              // 

#define _PACN2      (*((volatile uchar*) (0x0063)))  // Pulse acc A count reg (default=$00)
#define _PACN0      (*((volatile uchar*) (0x0065)))  // Pulse acc B count reg (default=$00)
#define _PACNT7       128                            // 
#define _PACNT6       64                             // 
#define _PACNT5       32                             // 
#define _PACNT4       16                             // 8 bit or low byte of 16 bit counter
#define _PACNT3       8                              // 
#define _PACNT2       4                              //
#define _PACNT1       2                              // 
#define _PACNT0       1                              // 

#define _MCCTL      (*((volatile uchar*) (0x0066)))  // 16bit Modulus Down-Cnt control reg (default=$00)
#define _MCZI        128                             // 1=modulus counter int is enabled
#define _MODMC       64                              // 0=counter goes up from modulus count reg to $0000, 1=resets when at $0000 to modul count reg 
#define _RDMCL       32                              // 0=read of modul count reg return current count, 1=returns value of load reg
#define _ICLAT       16                              // 1=force tc0-tc3 and acc's to latch to holding reg's & clears pulse acc
#define _FLMC        8                               // mcen must =1:loads modula counter with load reg value
#define _MCEN        4                               // 1= modula counter enabled
#define _MCPR1       2                               // 0=prescale of 1 3=prescale of 16
#define _MCPR0       1                               // 

#define _MCFLG      (*((volatile uchar*) (0x0067)))  // 16bit Modulus Down-Cnt flag reg (default=$00)
#define _MCZF        128                             // 1=when modulus down cnt = 0000 (write=1 clears flag)
#define _POLF3       8                               //  
#define _POLF2       4                               // 0=falling edge caused input capture, 1=rising edge caused input capture
#define _POLF1       2                               // 
#define _POLF0       1                               // 

#define _ICPAR      (*((volatile uchar*) (0x0068)))  // Input control pulse acc reg (default=$00)
#define _PA3EN       8                               //  
#define _PA2EN       4                               // 0=8bit pulse acc off, 1=8bit pulse acc on
#define _PA1EN       2                               // 
#define _PA0EN       1                               // 

#define _DLYCT      (*((volatile uchar*) (0x0069)))  // Delay counter control reg (default=$00)
#define _DLY1        2                               // delays pulse to filter narrow input pulses 
#define _DLY0        1                               // 0=bypassed 1=256busclkcycles 2=512 3=1024

#define _ICOVW      (*((volatile uchar*) (0x006A)))  // Input control overwrite reg (default=$00)
#define _NOVW7       128                             // 1=capture register cannot be overwriten (to give time to read)
#define _NOVW6       64                              //  
#define _NOVW5       32                              //
#define _NOVW4       16                              // 
#define _NOVW3       8                               // 
#define _NOVW2       4                               // 
#define _NOVW1       2                               // 
#define _NOVW0       1                               // 

#define _ICSYS      (*((volatile uchar*) (0x006B)))  // Input control system control reg (default=$00)
#define _SH37        128                             // 0=normal, 1=channel 3 and 7 share same action
#define _SH26        64                              //  
#define _SH15        32                              //
#define _SH044       16                              // 
#define _TFMOD       8                               // 0=timer flags c3f-c0f(tflg1) set when valid input on pin, 1=flags set only on latch
#define _PACMX       4                               // 0=normal, 1=pulse acc stops at $FF and does not roll over
#define _BUFEN       2                               // 1=input cap and pulse acc hold reg is enabled
#define _LATQ        1                               // 0=queue mode (input pin), 1=latch mode

#define RESRV1C     (*((volatile uchar*) (0x006C)))  // Reserved (not used)
#define RESRV1D     (*((volatile uchar*) (0x006D)))  // Reserved (not used)
#define RESRV1E     (*((volatile uchar*) (0x006E)))  // Reserved (not used)
#define RESRV1F     (*((volatile uchar*) (0x006F)))  // Reserved (not used)

#define _PBCTL      (*((volatile uchar*) (0x0070)))  // 16bit pulse acc B control reg (default=$00)
#define _PBEN        2                               // 1=16bit pulse acc B enabled, 0=8 bit enabled 
#define _PBOVI       1                               // 1=int request if PBOVF is set (enabled)

#define _PBFLG      (*((volatile uchar*) (0x0071)))  // Pulse acc B flag reg (default=$00)
#define _PBOVF       2                               // 1=8 or 16bit pulse acc B overflows to $0000 (write 1 to clear)

#define _PA3H       (*((volatile uchar*) (0x0072)))  // 8 bit Pulse acc holding reg (default=$00)
#define _PA2H       (*((volatile uchar*) (0x0073)))  // 8 bit Pulse acc holding reg (default=$00)
#define _PA1H       (*((volatile uchar*) (0x0074)))  // 8 bit Pulse acc holding reg (default=$00)
#define _PA0H       (*((volatile uchar*) (0x0075)))  // 8 bit Pulse acc holding reg (default=$00)

#define _MCCNT      (*((volatile uint*) (0x0076)))   // Modulus Down-Counter Count reg (default=$0000) 
#define _TC0H       (*((volatile uint*) (0x0078)))   // Timer input capture holding reg (default=$0000) 
#define _TC1H       (*((volatile uint*) (0x007A)))   // Timer input capture holding reg (default=$0000) 
#define _TC2H       (*((volatile uint*) (0x007C)))   // Timer input capture holding reg (default=$0000) 
#define _TC3H       (*((volatile uint*) (0x007E)))   // Timer input capture holding reg (default=$0000) 


/*------------------------------------------------------------------------------------*/
/* Analog      to Digital Module  (0= base + $0080-$009F) (1= base + $0120-$013F)     */
/*------------------------------------------------------------------------------------*/
#define RESRV20     (*((volatile uchar*) (0x0080)))  // Reserved (not used)
#define RESRV21     (*((volatile uchar*) (0x0081)))  // Reserved (not used)
#define RESRV22     (*((volatile uchar*) (0x0120)))  // Reserved (not used)
#define RESRV23     (*((volatile uchar*) (0x0121)))  // Reserved (not used)


#define _ATDCTL2    (*((volatile uchar*) (0x0082)))  // ATD control reg2 (default=$00)
#define _ATDCTL12   (*((volatile uchar*) (0x0122)))  // ATD control reg2 (default=$00)
#define _ADPU         128                            // 0=normal, 1=power down ATD
#define _AFFC         64                             // 1=fast flag clear, 0=normal flag clear 
#define _AWAI         32                             // 1=power down during wait mode
#define _ETRIGLE     16                              // 
#define _ETRIGP       8                              // 0=falling edge, 1=rising edge, 2=low level, 3=high level 
#define _ETRIGE       4                              // 1=external trigger on
#define _ASCIE        2                              // 1=ATD int request when ASCIF=1
#define _ASCIF        1                              // 1=ATD seq complete int pending, 0=no ATD int occured

#define _ATDCTL3    (*((volatile uchar*) (0x0083)))  // ATD control reg3 (default=$20)
#define _ATDCTL13   (*((volatile uchar*) (0x0123)))  // ATD control reg3 (default=$20)
#define _S8C         64                              //  
#define _S4C         32                              // 0=8conversions, 1=1 to 8 to 15=8 converstions
#define _S2C         16                              // 
#define _S1C         8                               //  
#define _FIFO        4                               // 0=1 seq in first reg, 1= seq are consecutive, wrap around
#define _FRZ1        2                               // 0=no freeze, 1=reserved, 2=finish then freeze, 3=freeze
#define _FRZ0        1                               // 

#define _ATDCTL4    (*((volatile uchar*) (0x0084)))  // ATD control reg4 (default=$05)
#define _ATDCTL14   (*((volatile uchar*) (0x0124)))  // ATD control reg4 (default=$05)
#define _SRES8       128                             // 1=8bit res, 0=10bit res
#define _SMP1        64                              // 
#define _SMP0        32                              // a/d conv clock periods sample time:0=2,1=4,2=8,3=16 
#define _PRS4        16                              // 
#define _PRS3        8                               // 
#define _PRS2        4                               // a/d conv clock= (busclock/(PRS + 1)) *0.5
#define _PRS1        2                               //
#define _PRS0        1                               // 

#define _ATDCTL5    (*((volatile uchar*) (0x0085)))  // ATD control reg5 (default=$00)
#define _ATDCTL15   (*((volatile uchar*) (0x0125)))  // ATD control reg5 (default=$00)
#define _DJM         128                             // 1=right justify, 0=left
#define _DSGN        64                              // 0=unsigned, 1=signed (2's comp)(not for right justify)
#define _SCAN        32                              // 0=single conv seq, 1=continuous
#define _MULT        16                              // 0=sample 1 channel, 1=sample channels starting from _CC-CA
#define _CC           4                              // 
#define _CB           2                              // 0=AN0 to 7-AN7
#define _CA           1                              // 

#define _ATDSTAT0   (*((volatile uchar*) (0x0086)))  // ATD Status reg0 (default=$00)
#define _ATDSTAT10  (*((volatile uchar*) (0x0126)))  // ATD Status reg0 (default=$00)
#define _SCF         128                             // 1=conversion down
#define _ETORF       32                              // 1=external trigger overun occured
#define _FIFOR       16                              // 1=overrun of conversion registers (when FIFO bit set)
#define _CC2         4                               // 
#define _CC1         2                               // points to register that will get next coversion result
#define _CC0         1                               // 

#define RESRV24     (*((volatile uchar*) (0x0087)))  // Reserved (not used)
#define RESRV25     (*((volatile uchar*) (0x0088)))  // Reserved (not used)
#define RESRV26     (*((volatile uchar*) (0x0089)))  // Reserved (not used)
#define RESRV27     (*((volatile uchar*) (0x008A)))  // Reserved (not used)
#define RESRV28     (*((volatile uchar*) (0x0127)))  // Reserved (not used)
#define RESRV29     (*((volatile uchar*) (0x0128)))  // Reserved (not used)
#define RESRV2A     (*((volatile uchar*) (0x0129)))  // Reserved (not used)
#define RESRV2B     (*((volatile uchar*) (0x012A)))  // Reserved (not used)

#define _ATDSTAT1   (*((volatile uchar*) (0x008B)))  // ATD Status reg1 (default=$00) (read only)
#define _ATDSTAT11  (*((volatile uchar*) (0x012B)))  // ATD Status reg1 (default=$00) (read only)
#define _CCF7        128                             // 
#define _CCF6        64                              // 
#define _CCF5        32                              // 
#define _CCF4        16                              // 1=conversion complete
#define _CCF3        8                               // 
#define _CCF2        4                               // 
#define _CCF1        2                               // 
#define _CCF0        1                               // 

#define RESRV2C     (*((volatile uchar*) (0x008C)))  // Reserved (not used)
#define RESRV2D     (*((volatile uchar*) (0x012C)))  // Reserved (not used)

#define _ATDDIEN    (*((volatile uchar*) (0x008D)))  // ATD input enable reg (default=$00)
#define _ATDDIEN1   (*((volatile uchar*) (0x012D)))  // ATD input enable reg (default=$00)
#define _IEN7        128                             // 
#define _IEN6        64                              // 
#define _IEN5        32                              // 
#define _IEN4        16                              // 1=enable input buffer (TURN ON PORT AD)
#define _IEN3        8                               // 
#define _IEN2        4                               // 
#define _IEN1        2                               // 
#define _IEN0        1                               // 

#define RESRV2E     (*((volatile uchar*) (0x008E)))  // Reserved (not used)
#define RESRV2F     (*((volatile uchar*) (0x012E)))  // Reserved (not used)

#define _PORTAD     (*((volatile uchar*) (0x008F)))  // PORT AD reg (default=$FF) (INPUT ONLY)
#define _PORTAD1    (*((volatile uchar*) (0x012F)))  // PORT AD reg (default=$FF) (INPUT ONLY)
#define _PTAD7       128                             // 
#define _PTAD6       64                              // 
#define _PTAD5       32                              // 
#define _PTAD4       16                              // 
#define _PTAD3       8                               // 
#define _PTAD2       4                               // 
#define _PTAD1       2                               // 
#define _PTAD0       1                               // 

#define _ATDDR0H    (*((volatile uchar*) (0x0090)))  // result data reg (default=$uu) (read only) 
#define _ATDDR1H    (*((volatile uchar*) (0x0092)))  // result data reg (default=$uu) (read only) 
#define _ATDDR2H    (*((volatile uchar*) (0x0094)))  // result data reg (default=$uu) (read only) 
#define _ATDDR3H    (*((volatile uchar*) (0x0096)))  // result data reg (default=$uu) (read only) 
#define _ATDDR4H    (*((volatile uchar*) (0x0098)))  // result data reg (default=$uu) (read only) 
#define _ATDDR5H    (*((volatile uchar*) (0x009A)))  // result data reg (default=$uu) (read only) 
#define _ATDDR6H    (*((volatile uchar*) (0x009C)))  // result data reg (default=$uu) (read only) 
#define _ATDDR7H    (*((volatile uchar*) (0x009E)))  // result data reg (default=$uu) (read only) 

#define _ATDDR0     (*((volatile uint*) (0x0090)))  // result data reg (default=$uu) (read only) 
#define _ATDDR1     (*((volatile uint*) (0x0092)))  // result data reg (default=$uu) (read only) 
#define _ATDDR2     (*((volatile uint*) (0x0094)))  // result data reg (default=$uu) (read only) 
#define _ATDDR3     (*((volatile uint*) (0x0096)))  // result data reg (default=$uu) (read only) 
#define _ATDDR4     (*((volatile uint*) (0x0098)))  // result data reg (default=$uu) (read only) 
#define _ATDDR5     (*((volatile uint*) (0x009A)))  // result data reg (default=$uu) (read only) 
#define _ATDDR6     (*((volatile uint*) (0x009C)))  // result data reg (default=$uu) (read only) 
#define _ATDDR7     (*((volatile uint*) (0x009E)))  // result data reg (default=$uu) (read only) 

#define _ATDDR0L    (*((volatile uchar*) (0x0091)))  // result data reg (default=$uu) (read only) 
#define _ATDDR1L    (*((volatile uchar*) (0x0093)))  // result data reg (default=$uu) (read only) 
#define _ATDDR2L    (*((volatile uchar*) (0x0095)))  // result data reg (default=$uu) (read only) 
#define _ATDDR3L    (*((volatile uchar*) (0x0097)))  // result data reg (default=$uu) (read only) 
#define _ATDDR4L    (*((volatile uchar*) (0x0099)))  // result data reg (default=$uu) (read only) 
#define _ATDDR5L    (*((volatile uchar*) (0x009B)))  // result data reg (default=$uu) (read only) 
#define _ATDDR6L    (*((volatile uchar*) (0x009D)))  // result data reg (default=$uu) (read only) 
#define _ATDDR7L    (*((volatile uchar*) (0x009F)))  // result data reg (default=$uu) (read only) 

#define _ATDDR10H   (*((volatile uchar*) (0x0130)))  // result data reg (default=$uu) (read only) 
#define _ATDDR11H   (*((volatile uchar*) (0x0132)))  // result data reg (default=$uu) (read only) 
#define _ATDDR12H   (*((volatile uchar*) (0x0134)))  // result data reg (default=$uu) (read only) 
#define _ATDDR13H   (*((volatile uchar*) (0x0136)))  // result data reg (default=$uu) (read only) 
#define _ATDDR14H   (*((volatile uchar*) (0x0138)))  // result data reg (default=$uu) (read only) 
#define _ATDDR15H   (*((volatile uchar*) (0x013A)))  // result data reg (default=$uu) (read only) 
#define _ATDDR16H   (*((volatile uchar*) (0x013C)))  // result data reg (default=$uu) (read only) 
#define _ATDDR17H   (*((volatile uchar*) (0x013E)))  // result data reg (default=$uu) (read only) 

#define _ATDDR10    (*((volatile uint*) (0x0130)))  // result data reg (default=$uu) (read only) 
#define _ATDDR11    (*((volatile uint*) (0x0132)))  // result data reg (default=$uu) (read only) 
#define _ATDDR12    (*((volatile uint*) (0x0134)))  // result data reg (default=$uu) (read only) 
#define _ATDDR13    (*((volatile uint*) (0x0136)))  // result data reg (default=$uu) (read only) 
#define _ATDDR14    (*((volatile uint*) (0x0138)))  // result data reg (default=$uu) (read only) 
#define _ATDDR15    (*((volatile uint*) (0x013A)))  // result data reg (default=$uu) (read only) 
#define _ATDDR16    (*((volatile uint*) (0x013C)))  // result data reg (default=$uu) (read only) 
#define _ATDDR17    (*((volatile uint*) (0x013E)))  // result data reg (default=$uu) (read only) 


#define _ATDDR10L   (*((volatile uchar*) (0x0131)))  // result data reg (default=$uu) (read only) 
#define _ATDDR11L   (*((volatile uchar*) (0x0133)))  // result data reg (default=$uu) (read only) 
#define _ATDDR12L   (*((volatile uchar*) (0x0135)))  // result data reg (default=$uu) (read only) 
#define _ATDDR13L   (*((volatile uchar*) (0x0137)))  // result data reg (default=$uu) (read only) 
#define _ATDDR14L   (*((volatile uchar*) (0x0139)))  // result data reg (default=$uu) (read only) 
#define _ATDDR15L   (*((volatile uchar*) (0x013B)))  // result data reg (default=$uu) (read only) 
#define _ATDDR16L   (*((volatile uchar*) (0x013D)))  // result data reg (default=$uu) (read only) 
#define _ATDDR17L   (*((volatile uchar*) (0x013F)))  // result data reg (default=$uu) (read only) 


/*------------------------------------------------------------------------------------*/
/*Pulse Width        Modulator Module  (base + $00A0-$00C7)                           */
/*------------------------------------------------------------------------------------*/

#define _PWME       (*((volatile uchar*) (0x00A0)))   // PWM enable reg (default=$00)
#define _PWME7       128                             // 1=channel enabled
#define _PWME6       64                              //  
#define _PWME5       32                              //
#define _PWME4       16                              // 
#define _PWME3       8                               //  
#define _PWME2       4                               //
#define _PWME1       2                               // 
#define _PWME0       1                               // 

#define _PWMPOL     (*((volatile uchar*) (0x00A1)))  // PWM polarity reg (default=$00)
#define _PPOL7       128                             // 1=high at start then low for duty count
#define _PPOL6       64                              //  
#define _PPOL5       32                              //
#define _PPOL4       16                              // 
#define _PPOL3       8                               //  
#define _PPOL2       4                               //
#define _PPOL1       2                               // 
#define _PPOL0       1                               // 

#define _PWMCLK     (*((volatile uchar*) (0x00A2)))  // PWM clock select reg (default=$00)
#define _PCLK7       128                             // 1=clock SB is source, 0=close B is source
#define _PCLK6       64                              //  
#define _PCLK5       32                              //
#define _PCLK4       16                              // 
#define _PCLK3       8                               //  
#define _PCLK2       4                               //
#define _PCLK1       2                               // 
#define _PCLK0       1                               // 

#define _PWMPRCLK   (*((volatile uchar*) (0x00A3)))  // PWM Prescale clock select reg (default=$00)
#define _PCKB2       64                              // prescale clockb (channels 2,3,6,7)
#define _PCKB1       32                              // 0=busclock,1=bc/2,2=bc/4,3=bc/8,4=bc/8,5=bc/16,6=bc/32
#define _PCKB0       16                              //
#define _PCKA2       4                               // prescale clocka (channels 0,1,4,5)
#define _PCKA1       2                               // 0=same as above
#define _PCKA0       1                               // 



#define _PWMCAE     (*((volatile uchar*) (0x00A4)))  // PWM Center align enable reg (default=$00)
#define _CAE7        128                             // 1=center aligned output mode, 0=left aligned output mode
#define _CAE6        64                              //  
#define _CAE5        32                              //
#define _CAE4        16                              // 
#define _CAE3        8                               //  
#define _CAE2        4                               //
#define _CAE1        2                               // 
#define _CAE0        1                               // 

#define _PWMCTL     (*((volatile uchar*) (0x00A5)))  // PWM control reg (default=$00)
#define _CON67       128                             // 1=concat channel 6 & 7 into 16bit PWM channel, 7 pin is output
#define _CON45       64                              //  
#define _CON23       32                              //
#define _CON01       16                              // 
#define _PSWAI       8                               // 1=stop pwm input clock in wait mode
#define _PFRZ        4                               // 1=disable pwm input clock in freeze mode

#define RESRV30     (*((volatile uchar*) (0x00A6)))  // Reserved (not used)
#define RESRV31     (*((volatile uchar*) (0x00A7)))  // Reserved (not used)

#define _PWMSCLA    (*((volatile uchar*) (0x00A8)))  // PWM scale A reg (default=$00)
                                                     // clock SA=clockA / (2*PWMSCLA)
                       	
#define _PWMSCLB    (*((volatile uchar*) (0x00A9)))  // PWM scale B reg (default=$00)
                                                     // clock SB=clockB / (2*PWMSCLB)
#define RESRV32     (*((volatile uchar*) (0x00AA)))  // Reserved (not used)
#define RESRV33     (*((volatile uchar*) (0x00AB)))  // Reserved (not used)
                       	
#define _PWMSCNT0   (*((volatile uchar*) (0x00AC)))  // PWM channel counter reg (default=$00)
#define _PWMSCNT1   (*((volatile uchar*) (0x00AD)))  // PWM channel counter reg (default=$00)
#define _PWMSCNT2   (*((volatile uchar*) (0x00AE)))  // PWM channel counter reg (default=$00)
#define _PWMSCNT3   (*((volatile uchar*) (0x00AF)))  // PWM channel counter reg (default=$00)
#define _PWMSCNT4   (*((volatile uchar*) (0x00B0)))  // PWM channel counter reg (default=$00)
#define _PWMSCNT5   (*((volatile uchar*) (0x00B1)))  // PWM channel counter reg (default=$00)
#define _PWMSCNT6   (*((volatile uchar*) (0x00B2)))  // PWM channel counter reg (default=$00)
#define _PWMSCNT7   (*((volatile uchar*) (0x00B3)))  // PWM channel counter reg (default=$00)
                      	
#define _PWMPER0    (*((volatile uchar*) (0x00B4)))  // PWM channel period reg (default=$FF)
#define _PWMPER1    (*((volatile uchar*) (0x00B5)))  // PWM channel period reg (default=$FF)
#define _PWMPER2    (*((volatile uchar*) (0x00B6)))  // PWM channel period reg (default=$FF)
#define _PWMPER3    (*((volatile uchar*) (0x00B7)))  // PWM channel period reg (default=$FF)
#define _PWMPER4    (*((volatile uchar*) (0x00B8))   // PWM channel period reg (default=$FF)
#define _PWMPER5    (*((volatile uchar*) (0x00B9)))  // PWM channel period reg (default=$FF)
#define _PWMPER6    (*((volatile uchar*) (0x00BA)))  // PWM channel period reg (default=$FF)
#define _PWMPER7    (*((volatile uchar*) (0x00BB)))  // PWM channel period reg (default=$FF)

#define _PWMDTY0    (*((volatile uchar*) (0x00BC)))  // PWM channel duty reg (default=$FF)
#define _PWMDTY1    (*((volatile uchar*) (0x00BD)))  // PWM channel duty reg (default=$FF)
#define _PWMDTY2    (*((volatile uchar*) (0x00BE)))  // PWM channel duty reg (default=$FF)
#define _PWMDTY3    (*((volatile uchar*) (0x00BF)))  // PWM channel duty reg (default=$FF)
#define _PWMDTY4    (*((volatile uchar*) (0x00C0)))  // PWM channel duty reg (default=$FF)
#define _PWMDTY5    (*((volatile uchar*) (0x00C1)))  // PWM channel duty reg (default=$FF)
#define _PWMDTY6    (*((volatile uchar*) (0x00C2)))  // PWM channel duty reg (default=$FF)
#define _PWMDTY7    (*((volatile uchar*) (0x00C3)))  // PWM channel duty reg (default=$FF)
                       	
#define _PWMSDN     (*((volatile uchar*) (0x00C4)))  // PWM shutdown reg (default=$00)
#define _PWMIF       128                             // 1=any change in pwm7in (write 1 to clear)
#define _PWMIE       64                              // 1=pwm int. is enabled
#define _PWMRSTRT    32                              // 1=starts pwm back up after shutdown
#define _PWMLVL      16                              // 1=pwm outputs forced to 1 at shutdown
#define _PWM7IN      4                               // current status of PWM7pin
#define _PWM7INL     2                               // if pwmif=1 then 1=active level high, 0=low
#define _PWM7ENA     1                               // 1=emergency feature on


/*------------------------------------------------------------------------------------*/
/* SCI Module       (0= base + $00C8-$00CF)  (1= base + $00D0-$00D7)                  */
/*------------------------------------------------------------------------------------*/
#define _SCIBD      (*((volatile uint*) (0x00C8)))   // SCI Baud rate high reg (default=$00)
#define _SCIBD1     (*((volatile uint*) (0x00D0)))   // SCI Baud rate high reg (default=$00)


#define _SCIBDH     (*((volatile uchar*) (0x00C8)))  // SCI Baud rate high reg (default=$00)
#define _SCIBDH1    (*((volatile uchar*) (0x00D0)))  // SCI Baud rate high reg (default=$00)
#define _SBR12       16                              // 
#define _SBR11       8                               //  
#define _SBR10       4                               // see below
#define _SBR9        2                               // 
#define _SBR8        1                               // 

#define _SCIBDL     (*((volatile uchar*) (0x00C9)))  // SCI Baud rate low reg (default=$04)
#define _SCIBDL1    (*((volatile uchar*) (0x00D1)))  // SCI Baud rate low reg (default=$04)
#define _SBR7        128                             // 
#define _SBR6        64                              //  
#define _SBR5        32                              //
#define _SBR4        16                              // sci baud rate = sci module clk / (16*br)
#define _SBR3        8                               //  br = 1 to 8191
#define _SBR2        4                               //
#define _SBR1        2                               // 
#define _SBR0        1                               // 

#define _SCICR1     (*((volatile uchar*) (0x00CA)))  // SCI Control reg1 (default=$00)
#define _SCICR11    (*((volatile uchar*) (0x00D2)))  // SCI Control reg1 (default=$00)
#define _LOOPS        128                            // 1=loop mode enabled (tx looped back to rx)
#define _SCISWAI      64                             // 1=sci disabled in wait mode 
#define _RSRC         32                             // 1=rx externally connected to tx, 0=internal
#define _M            16                             // 1=9 data bits, 0=8 data bits
#define _WAKE         8                              // 1=address mark wakeup, 0=idle line wakeup 
#define _ILT          4                              // 1=idle char bit count begins after stop bit
#define _PE           2                              // 1=parity enabled
#define _PT           1                              // 1=odd parity, 0=even

#define _SCICR2     (*((volatile uchar*) (0x00CB)))  // SCI Control reg2 (default=$00)
#define _SCICR12    (*((volatile uchar*) (0x00D3)))  // SCI Control reg2 (default=$00)
#define _TIE         128                             // 1=tdre int req enabled
#define _TCIE        64                              // 1=tc int req enabled 
#define _RIE         32                              // 1=rdrf and or int req enabled
#define _ILIE        16                              // 1=idle int req enabled
#define _TE          8                               // 1=transmitter enabled 
#define _RE          4                               // 1=receiver enabled
#define _RWU         2                               // 1=rwu enables wakeup function, 0=normal operation
#define _SBK         1                               // 1=transmit break characters

#define _SCISR1     (*((volatile uchar*) (0x00CC)))  // SCI status reg1 (default=$c0)
#define _SCISR11    (*((volatile uchar*) (0x00D4)))  // SCI status reg1 (default=$c0)
#define _TDRE        128                             // 1=byte transferred to tx shift reg, tx data reg empty, 
#define _TC           64                             // 1=no transmission in progress, 0=trans in prog. 
#define _RDRF         32                             // 1=RX data avail in SCI data reg.
#define _IDLE         16                             // 1=RX input is idle
#define _OR           8                              // 1=Overrun 
#define _NF           4                              // 1=Noise
#define _FE           2                              // 1=Framing error
#define _PF           1                              // 1=Parity error

#define _SCISR2     (*((volatile uchar*) (0x00CD)))  // SCI status reg2 (default=$00)
#define _SCISR12    (*((volatile uchar*) (0x00D5)))  // SCI status reg2 (default=$00)
#define _SBK13       4                               // 1=break char si 13 or 14 bit long, 0=10 or 11 long
#define _TXDIR       2                               // 1=txd pin output in single wire mode, 0=txd pin input in signle wire mode
#define _RAF         1                               // 1=reception in progress

#define _SCIDRH     (*((volatile uchar*) (0x00CE)))  // SCI Data High reg (default=$00)
#define _SCIDRH1    (*((volatile uchar*) (0x00D6)))  // SCI Data High reg (default=$00)
#define _R8           128                            // 9th bit
#define _T8           64                             // 

#define _SCIDRL     (*((volatile uchar*) (0x00CF)))  // SCI Data Low reg (default=$00)
#define _SCIDRL1    (*((volatile uchar*) (0x00D7)))  // SCI Data Low reg (default=$00)
#define _R7           128                            // 
#define _T7           128                            // 
#define _R6           64                             // 
#define _T6           64                             // 
#define _R5           32                             // 
#define _T5           32                             // 
#define _R4           16                             // 
#define _T4           16                             // 
#define _R3           8                              // 
#define _T3           8                              // 
#define _R2           4                              // 
#define _T2           4                              // 
#define _R1           2                              // 
#define _T1           2                              // 
#define _R0           1                              // 
#define _T0           1                              // 


/*------------------------------------------------------------------------------------*/
/* SPI Module (0= base + $00D8-$00DF) (1= base + $00F0-$00F7) (2= base + $00F8-$00FF) */
/*------------------------------------------------------------------------------------*/
#define _SPICR1     (*((volatile uchar*) (0x00D8)))  // SPI control reg1 (default=$04)
#define _SPICR11    (*((volatile uchar*) (0x00F0)))  // SPI control reg1 (default=$04)
#define _SPICR21    (*((volatile uchar*) (0x00F8)))  // SPI control reg1 (default=$04)
#define _SPIE        128                             // 1=SPI enabled
#define _SPE         64                              // 1=SPI port pins used for SPI functions 
#define _SPTIE       32                              // 1=SPTEF int enabled
#define _MSTR        16                              // 1=Master mode, 0=Slave mode
#define _CPOL        8                               // 1=active low clocks selected, SCK idle high, 0=high, SCK low 
#define _CPHA        4                               // 1=1st SCK edge at beg of 8 cycle transfer, 0=1/2 cycle into 8 cycle
#define _SSOE        2                               // when mstr=1: 1=output, 0=input with modf feature
#define _LSBFE       1                               // 1=data xferd lsb first, 0=msb first

#define _SPICR2     (*((volatile uchar*) (0x00D9)))  // SPI control reg2 (default=$00)
#define _SPICR12    (*((volatile uchar*) (0x00F1)))  // SPI control reg2 (default=$00)
#define _SPICR22    (*((volatile uchar*) (0x00F9)))  // SPI control reg2 (default=$00)
#define _MODFEN       16                             // 1=enable setting the modf error, 0=no modf error
#define _BIDIROE     8                               // 1=output buffer on,0=buffer off
#define _SPISWAI     2                               // 1=stop spi clock in wait mode
#define _SPC0         1                              // 1=bidirection pin config on

#define _SPIBR      (*((volatile uchar*) (0x00DA)))  // SPI Status reg (default=$00)
#define _SPIBR1     (*((volatile uchar*) (0x00F2)))   // SPI Baud rate reg (default=$00)
#define _SPIBR2     (*((volatile uchar*) (0x00FA)))  // SPI Baud rate reg (default=$00)
#define _SPPR2       64                              //
#define _SPPR1       32                              // baudratedivisor=(SPPR + 1)* 2^(SPR+1)
#define _SPPR0       16                              //
#define _SPR2        4                               // baudrate= Bus clock/baudratedivisor
#define _SPR1        2                               //
#define _SPR0        1                               //

#define _SPISR      (*((volatile uchar*) (0x00DB)))  // SPI Status reg (default=$00)
#define _SPISR1     (*((volatile uchar*) (0x00F3)))  // SPI Status reg (default=$00)
#define _SPISR2     (*((volatile uchar*) (0x00FB)))  // SPI Status reg (default=$00)
#define _SPIF        128                             // 1=new data in SPIDR (clear by reading this reg and data reg)
#define _SPTEF       32                              // 1=SPI data reg empty (write to data reg only when this is high)
#define _MODF        16                              // 1=mode fault occured

#define RESRV34     (*((volatile uchar*) (0x00DC)))  // Reserved (not used)
#define RESRV35     (*((volatile uchar*) (0x00F4)))  // Reserved (not used)
#define RESRV36     (*((volatile uchar*) (0x00FC)))  // Reserved (not used)

#define _SPIDR      (*((volatile uchar*) (0x00DD)))  // SPI Status reg2 (default=$00)
#define _SPIDR1     (*((volatile uchar*) (0x00F5)))  // SPI Status reg2 (default=$00)
#define _SPIDR2     (*((volatile uchar*) (0x00FD)))  // SPI Status reg2 (default=$00)


#define RESRV37     (*((volatile uchar*) (0x00DE)))  // Reserved (not used)
#define RESRV38     (*((volatile uchar*) (0x00F6)))  // Reserved (not used)
#define RESRV39     (*((volatile uchar*) (0x00FE)))  // Reserved (not used)

#define RESRV3A     (*((volatile uchar*) (0x00DF)))  // Reserved (not used)
#define RESRV3B     (*((volatile uchar*) (0x00F7)))  // Reserved (not used)
#define RESRV3C     (*((volatile uchar*) (0x00FF)))  // Reserved (not used)


/*------------------------------------------------------------------------------------*/
/* I^C Module       (base + $00E0-$00E7)                                              */
/*------------------------------------------------------------------------------------*/
 
#define _IBAD       (*((volatile uchar*) (0x00E0))) // gfgh

#define _IBFD       (*((volatile uchar*) (0x00E1))) // gdfgh

#define _IBCR       (*((volatile uchar*) (0x00E2))) // dghdgh 
 
#define _IBEN         128                             // 0=transfer in progress, 1=transfer complete
#define _IBIE        64                              // 0=not addressed, 1=addressed as slave
#define _MSSL         32                              // 0=not busy, 1=bus is busy
#define _TXRX        16                              // 0=normal 1=arbitration lost (bad)
#define _TXAK         8                               // when iaas=1: 0=slave rx, master writing to slave, 1=slave tx, master reading from slave
#define _RSTA        4                               // 1=ibus interuppt flag (write 1 to clear)
#define _IBSWAI        1                               // 0=ack received, 1=no ack received

 
 
#define _IBSR       (*((volatile uchar*) (0x00E3)))  // I^C status reg (default=$80)
#define _TCF         128                             // 0=transfer in progress, 1=transfer complete
#define _IAAS        64                              // 0=not addressed, 1=addressed as slave
#define _IBB         32                              // 0=not busy, 1=bus is busy
#define _IBAL        16                              // 0=normal 1=arbitration lost (bad)
#define _SRW         4                               // when iaas=1: 0=slave rx, master writing to slave, 1=slave tx, master reading from slave
#define _IBIF        2                               // 1=ibus interuppt flag (write 1 to clear)
#define _RXAK        1                               // 0=ack received, 1=no ack received

#define _IBDR       (*((volatile uchar*) (0x00E4)))  // I^C Data I/O reg (default=$00)

#define RESRV3D     (*((volatile uchar*) (0x00E5)))  // Reserved (not used)
#define RESRV3E     (*((volatile uchar*) (0x00E6)))  // Reserved (not used)
#define RESRV3F     (*((volatile uchar*) (0x00E7)))  // Reserved (not used)


/*------------------------------------------------------------------------------------*/
/* Flash Module     (base + $0100-$010F)                                              */
/*------------------------------------------------------------------------------------*/
#define _FCLKDIV    (*((volatile uchar*) (0x0100)))  // Flash clock divider reg (default=$00)
#define _NVLD        128                             // 0=register has not been written since last reset, 1= it has
#define _PRDIV8      64                              // 1=divide flash input osc clck / 8
#define _FDIV5       32                              //
#define _FDIV4       16                              //
#define _FDIV3       8                               // divide flash input ocs clkc by value in these bits (max 512)
#define _FDIV2       4                               //
#define _FDIV1       2                               //
#define _FDIV0       1                               //

#define _FSEC       (*((volatile uchar*) (0x0101)))  // Flash Security reg (default=value stored at $ff0f)
#define _KEYEN       128                             // 0=backdoor to flash is off, 1=on
#define _NV6         64                              //
#define _NV5         32                              //
#define _NV4         16                              // NV are user non-volite bits (NV6-NV2)
#define _NV3         8                               //
#define _NV2         4                               //
#define _SEC1        2                               //
#define _SEC0        1                               // 0 or 1=secured,2=unsecured,3=secured

#define _FTSTMOD    (*((volatile uchar*) (0x0102)))  // Flash test mode reg (default=$00) (special mode only)
#define _WRALL       16                              // 1=write to all reg banks, 0=write only to bank selected by BKSEL

#define _FCNFG      (*((volatile uchar*) (0x0103)))  // Flash Configuration reg (default=$00)
#define _CBEIE       128                             // 1=int req enabled for CBEIF flag
#define _CCIE        64                              // 1=int req enabled for CCIF flag
#define _KEYACC      32                              // 0=flash writes are start of program or erase seq, 1=writes to flash are keys to open backdoor
#define _BKSEL1      2                               //
#define _BKSEL0      1                               // 0=Flash bank 0 to  3=Flash bank 3

#define _FPROT      (*((volatile uchar*) (0x0104)))  // Flash protection reg (default=value stored at bank0=$ff0d to bank3=$ff0a)
#define _FPOPEN      128                             // 0=entire flash array is protected, 1=banks not protected can be programmed/erased
#define _PNV6        64                              //
#define _FPHDIS      32                              // 1=disable protected higher address range flash
#define _FPHS1       16                              //
#define _FPHS0       8                               // 0=2kbyte, 1=4k, 2=8k, 3=16k
#define _FPLDIS      4                               // 1=disable protected lower address range flash
#define _FPLS1       2                               // 
#define _FPLS0       1                               // 0=512byte, 1=1k, 2=2k, 3=4k

#define _FSTAT      (*((volatile uchar*) (0x0105)))  // Flash Status flag reg (default=$C0)
#define _CBEIF       128                             // 1=buffers ready for new command (write 1 to clear)
#define _CCIF        64                              // 1=all commands are completed
#define _PVIOL       32                              // 1=protection violation has occured
#define _ACCERR      16                              // 1=Access error has occured
#define _BLANK       4                               // 1=Flash block verified as erased, 0=not erased if erase verfiy command sent

#define _FCMD       (*((volatile uchar*) (0x0106)))  // Flash Command reg (default=$00)
#define _CMDB6       128                             //
#define _CMDB5       64                              //
#define _CMDB2       32                              //
#define _CMDB0       16                              // $05=erase verify,$20=byte program, $40=Sector erase, $41=Mass Erase

#define RESRV40     (*((volatile uchar*) (0x0107)))  // Reserved (not used)


#define _FADDRHI    (*((volatile uchar*) (0x0108)))  // Flash 16bit address High reg (default=$00) (bit 7 not used)
#define _FADDRLI    (*((volatile uchar*) (0x0109)))  // Flash 16bit address Low reg (default=$00)
                                                     // for sector erase address in Low doent matter
                                                     // for mass erase neither address matters

/*------------------------------------------------------------------------------------*/
/* EEPROM Module    (base + $0110-$011B)                                              */
/*------------------------------------------------------------------------------------*/
#define _ECLKDIV    (*((volatile uchar*) (0x0110)))  // EEPROM clock divider reg (default=$00)
#define _EDIVLD       128                            // 0=register has not been written since last reset, 1= it has
#define _EPRDIV8     64                              // 1=divide EEPROM input osc clck / 8
#define _EDIV5        32                             //
#define _EDIV4        16                             //
#define _EDIV3        8                              // divide EEPROM input ocs clkc by value in these bits (max 512)
#define _EDIV2        4                              // 
#define _EDIV1        2                              // 
#define _EDIV0        1                              // 

#define RESRV41     (*((volatile uchar*) (0x0111)))  // Reserved (not used)
#define RESRV42     (*((volatile uchar*) (0x0112)))  // Reserved (not used)

#define _ECNFG      (*((volatile uchar*) (0x0113)))  // EEPROM Configuration reg (default=$00)
#define _ECBEIE      128                             // 1=int req enabled for ECBEIF flag
#define _ECCIE       64                              // 1=int req enabled for ECCIF flag

#define _EPROT      (*((volatile uchar*) (0x0114)))  // EEPROM protection reg (default=value stored at eeprom array=$_ffd)
#define _EPOPEN      128                             // 0=entire EEPROM is protected, 1=sectors not protected can be programmed/erased
#define _ENV6        64                              //
#define _ENV5        32                              //
#define _ENV4        16                              //
#define _EPDIS       8                               // 1=protection disabled, 0=enabled
#define _EP2         4                               //
#define _EP1         2                               //
#define _EP0         1                               // 0=top 64bytes,1=128,2=256,3=320, etc protected

#define _ESTAT      (*((volatile uchar*) (0x0115)))  // EEPROM Status flag reg (default=$C0)
#define _ECBEIF       128                            // 1=buffers ready for new command (write 1 to clear)
#define _ECCIF        64                             // 1=all commands are completed
#define _EPVIOL       32                             // 1=protection violation has occured
#define _EACCERR     16                              // 1=Access error has occured
#define _EBLANK       4                              // 1=EEPROM verified as erased, 0=not erased if erase verfiy command sent

#define _ECMD       (*((volatile uchar*) (0x0116)))  // EEPROM Command reg (default=$00)
#define _ECMDB6      128                             //
#define _ECMDB5      64                              //
#define _ECMDB2      32                              //
#define _ECMDB0      16                              // $05=erase verify,$20=word program, $40=Sector erase, $41=Mass Erase, $60=sector Modify

#define RESRV43     (*((volatile uchar*) (0x0117)))  // Reserved (not used)
#define RESRV44     (*((volatile uchar*) (0x0118)))  // Reserved (not used)
#define RESRV45     (*((volatile uchar*) (0x0119)))  // Reserved (not used)
#define RESRV46     (*((volatile uchar*) (0x011A)))  // Reserved (not used)
#define RESRV47     (*((volatile uchar*) (0x011B)))  // Reserved (not used)


/*------------------------------------------------------------------------------------*/
/* PIM Module       (base + $0240-$27F)                                               */
/*------------------------------------------------------------------------------------*/
#define _PTT        (*((volatile uchar*) (0x0240)))  // Port T reg (default=$00)
#define _PTIT       (*((volatile uchar*) (0x0241)))  // Port T input reg (default=$00) (read only)
#define _DDRT       (*((volatile uchar*) (0x0242)))  // Data Direction T reg (default=$00) 1=out 0=in
#define _RDRT       (*((volatile uchar*) (0x0243)))  // Port T reduced drive reg (default=$00) (0=full strength, 1=1/3 full)
#define _PERT       (*((volatile uchar*) (0x0244)))  // Port T Pull device enable reg (default=$00) (0=disabled, 1=pull on)
#define _PPST       (*((volatile uchar*) (0x0245)))  // Port T Polarity select reg (default=$00) (0=pull-up , 1=pull-down)
#define _PTT7        128
#define _PTT6        64
#define _PTT5        32
#define _PTT4        16
#define _PTT3        8
#define _PTT2        4
#define _PTT1        2
#define _PTT0        1

#define RESRV48     (*((volatile uchar*) (0x0246)))  // Reserved (not used)
#define RESRV49     (*((volatile uchar*) (0x0247)))  // Reserved (not used)

#define _PTS        (*((volatile uchar*) (0x0248)))  // Port S reg (default=$00)
#define _PTIS       (*((volatile uchar*) (0x0249)))  // Port S input reg (default=$00) (read only)
#define _DDRS       (*((volatile uchar*) (0x024A)))  // Data Direction S reg (default=$00) 1=out 0=in
#define _RDRS       (*((volatile uchar*) (0x024B)))  // Port S reduced drive reg (default=$00) (0=full strength, 1=1/3 full)
#define _PERS       (*((volatile uchar*) (0x024C)))  // Port S Pull device enable reg (default=$00) (0=disabled, 1=pull on)
#define _PPSS       (*((volatile uchar*) (0x024D)))  // Port S Polarity select reg (default=$00) (0=pull-up , 1=pull-down)
#define _WOMS       (*((volatile uchar*) (0x024E)))  // Port S Wired or mode reg (default=$00) (0=push-pull , 1=open-drain)
#define _PTS7        128
#define _PTS6        64
#define _PTS5        32
#define _PTS4        16
#define _PTS3        8
#define _PTS2        4
#define _PTS1        2
#define _PTS0        1

#define RESRV4A     (*((volatile uchar*) (0x024F)))  // Reserved (not used)


#define _PTM        (*((volatile uchar*) (0x0250)))  // Port M reg (default=$00)
#define _PTIM       (*((volatile uchar*) (0x0251)))  // Port M input reg (default=$00) (read only)
#define _DDRM       (*((volatile uchar*) (0x0252)))  // Data Direction M reg (default=$00) 1=out 0=in
#define _RDRM       (*((volatile uchar*) (0x0253)))  // Port M reduced drive reg (default=$00) (0=full strength, 1=1/3 full)
#define _PERM       (*((volatile uchar*) (0x0254)))  // Port M Pull device enable reg (default=$00) (0=disabled, 1=pull on)
#define _PPSM       (*((volatile uchar*) (0x0255)))  // Port M Polarity select reg (default=$00) (0=pull-up , 1=pull-down)
#define _WOMM       (*((volatile uchar*) (0x0256)))  // Port M Wired or mode reg (default=$00) (0=push-pull , 1=open-drain)
#define _PTM7        128
#define _PTM6        64
#define _PTM5        32
#define _PTM4        16
#define _PTM3        8
#define _PTM2        4
#define _PTM1        2
#define _PTM0        1

#define _MODRR      (*((volatile uchar*) (0x0257)))  // Port M Module routing reg (default=$00)
#define _MODRR6      64                              // SPI2 pin routing
#define _MODRR5      32                              // SPI1 pin routing
#define _MODRR4      16                              // SPI0 pin routing
#define _MODRR3      8                               // CAN4 pin routing
#define _MODRR2      4                               // CAN4 pin routing
#define _MODRR1      2                               // CAN0 pin routing
#define _MODRR0      1                               // CAN0 pin routing

#define _PTP        (*((volatile uchar*) (0x0258)))  // Port P reg (default=$00)
#define _PTIP       (*((volatile uchar*) (0x0259)))  // Port P input reg (default=$00) (read only)
#define _DDRP       (*((volatile uchar*) (0x025A)))  // Data Direction P reg (default=$00) 1=out 0=in
#define _RDRP       (*((volatile uchar*) (0x025B)))  // Port P reduced drive reg (default=$00) (0=full strength, 1=1/3 full)
#define _PERP       (*((volatile uchar*) (0x025C)))  // Port P Pull device enable reg (default=$00) (0=disabled, 1=pull on)
#define _PPSP       (*((volatile uchar*) (0x025D)))  // Port P Polarity select reg (default=$00) (0=pull-up , 1=pull-down)
                                                     //     (0=falling signal will set flag, 1=rising signal will set flag)
#define _PIEP       (*((volatile uchar*) (0x025E)))  // Port P interrupt enable reg (default=$00) (1=int enabled for pin)
#define _PIFP       (*((volatile uchar*) (0x025F)))  // Port P interrupt flag reg (default=$00) (1=edge triggerd) (write 1 to clear)
#define _PTP7        128
#define _PTP6        64
#define _PTP5        32
#define _PTP4        16
#define _PTP3        8
#define _PTP2        4
#define _PTP1        2
#define _PTP0        1

#define _PTH        (*((volatile uchar*) (0x0260)))  // Port H reg (default=$00)
#define _PTIH       (*((volatile uchar*) (0x0261)))  // Port H input reg (default=$00) (read only)
#define _DDRH       (*((volatile uchar*) (0x0262)))  // Data Direction H reg (default=$00) 1=out 0=in
#define _RDRH       (*((volatile uchar*) (0x0263)))  // Port H reduced drive reg (default=$00) (0=full strength, 1=1/3 full)
#define _PERH       (*((volatile uchar*) (0x0264)))  // Port H Pull device enable reg (default=$00) (0=disabled, 1=pull on)
#define _PPSH       (*((volatile uchar*) (0x0265)))  // Port H Polarity select reg (default=$00) (0=pull-up , 1=pull-down)
                                                     //     (0=falling signal will set flag, 1=rising signal will set flag)
#define _PIEH       (*((volatile uchar*) (0x0266)))  // Port H interrupt enable reg (default=$00) (1=int enabled for pin)
#define _PIFH       (*((volatile uchar*) (0x0267)))  // Port H interrupt flag reg (default=$00) (1=edge triggerd) (write 1 to clear)
#define _PTH7        128
#define _PTH6        64
#define _PTH5        32
#define _PTH4        16
#define _PTH3        8
#define _PTH2        4
#define _PTH1        2
#define _PTH0        1

#define _PTJ        (*((volatile uchar*) (0x0268)))  // Port J reg (default=$00) (bit7,6,1,0 only)
#define _PTIJ       (*((volatile uchar*) (0x0269)))  // Port J input reg (default=$00) (read only)
#define _DDRJ       (*((volatile uchar*) (0x026A)))  // Data Direction J reg (default=$00) 1=out 0=in
#define _RDRJ       (*((volatile uchar*) (0x026B)))  // Port J reduced drive reg (default=$00) (0=full strength, 1=1/3 full)
#define _PERJ       (*((volatile uchar*) (0x026C)))  // Port J Pull device enable reg (default=$00) (0=disabled, 1=pull on)
#define _PPSJ       (*((volatile uchar*) (0x026D)))  // Port J Polarity select reg (default=$00) (0=pull-up , 1=pull-down)
                                                     //     (0=falling signal will set flag, 1=rising signal will set flag)
#define _PIEJ       (*((volatile uchar*) (0x026E)))  // Port J interrupt enable reg (default=$00) (1=int enabled for pin)
#define _PIFJ       (*((volatile uchar*) (0x026F)))  // Port J interrupt flag reg (default=$00) (1=edge triggerd) (write 1 to clear)
#define _PTJ7        128
#define _PTJ1        2
#define _PTJ0        1

#define RESRV4B     (*((volatile uchar*) (0x0270)))  // Reserved (not used)
#define RESRV4C     (*((volatile uchar*) (0x0271)))  // Reserved (not used)
#define RESRV4D     (*((volatile uchar*) (0x0272)))  // Reserved (not used)
#define RESRV4E     (*((volatile uchar*) (0x0273)))  // Reserved (not used)
#define RESRV4F     (*((volatile uchar*) (0x0274)))  // Reserved (not used)
#define RESRV50     (*((volatile uchar*) (0x0275)))  // Reserved (not used)
#define RESRV51     (*((volatile uchar*) (0x0276)))  // Reserved (not used)
#define RESRV52     (*((volatile uchar*) (0x0277)))  // Reserved (not used)
#define RESRV53     (*((volatile uchar*) (0x0278)))  // Reserved (not used)
#define RESRV54     (*((volatile uchar*) (0x0279)))  // Reserved (not used)
#define RESRV55     (*((volatile uchar*) (0x027A)))  // Reserved (not used)
#define RESRV56     (*((volatile uchar*) (0x027B)))  // Reserved (not used)
#define RESRV57     (*((volatile uchar*) (0x027C)))  // Reserved (not used)
#define RESRV58     (*((volatile uchar*) (0x027D)))  // Reserved (not used)
#define RESRV59     (*((volatile uchar*) (0x027E)))  // Reserved (not used)
#define RESRV5A     (*((volatile uchar*) (0x027F)))  // Reserved (not used)


/*----------------------------------------------------------------------------------------------------------------*/
/* CAN Module (0=base+$0140-$017F)(1=base+$0180-$01BF)(2=base+$01C0-$01FF)(3=base+$0200-$023F)(4=base+$0280-02BF) */
/*----------------------------------------------------------------------------------------------------------------*/
#define _CANCTL0    (*((volatile uchar*) (0x0140)))  // CAN0 Control reg0 (default=$01)
#define _CANCTL10   (*((volatile uchar*) (0x0180)))  // CAN1 Control reg0 (default=$01)
#define _CANCTL20   (*((volatile uchar*) (0x01C0)))  // CAN2 Control reg0 (default=$01)
#define _CANCTL30   (*((volatile uchar*) (0x0200)))  // CAN3 Control reg0 (default=$01)
#define _CANCTL40   (*((volatile uchar*) (0x0280)))  // CAN4 Control reg0 (default=$01)
#define _RXFRM       128                             // 1=valid message received since last clear of this flag (write 1 to clear)
#define _RXACT       64                              // 1=can is receiving , 0=can is transmiting or idle
#define _CSWAI       32                              // 1=can stops when in idle mode
#define _SYNCH       16                              // 1=can is synch to can bus
#define _TIME        8                               // 1=enable internal can timer
#define _WUPE        4                               // 1=wake up enabled- can is able to restart, 0=can ignores traffic on can
#define _SLPRQ       2                               // 1=sleep mode (wake up if wupe bit =1
#define _INITRQ      1                               // 0=normal, 1=initialzation mode

#define _CANCTL1    (*((volatile uchar*) (0x0141)))  // CAN0 Control reg0 (default=$11)
#define _CANCTL11   (*((volatile uchar*) (0x0181)))  // CAN1 Control reg0 (default=$11)
#define _CANCTL21   (*((volatile uchar*) (0x01C1)))  // CAN2 Control reg0 (default=$11)
#define _CANCTL31   (*((volatile uchar*) (0x0201)))  // CAN3 Control reg0 (default=$11)
#define _CANCTL41   (*((volatile uchar*) (0x0281)))  // CAN4 Control reg1 (default=$11)
#define _CANE        128                             // 1=can module on
#define _CLKSRC      64                              // 1=can clock is bus clock, 0=is osc clock
#define _LOOPB       32                              // 1=loop back self test mode on
#define _LISTEN      16                              // 0=normal, 1=listen only mode
#define _WUPM        4                               // 1=wake up only after big pulse, 0=normal
#define _SLPAK       2                               // 1=sleep mode acvtive, 0=running and normal
#define _INITAK      1                               // 1=sleep mode request, 0=normal

#define _CANBTR0    (*((volatile uchar*) (0x0142)))  // CAN0 Bus Timing reg0 (default=$00)
#define _CANBTR10   (*((volatile uchar*) (0x0182)))  // CAN1 Bus Timing reg0 (default=$00)
#define _CANBTR20   (*((volatile uchar*) (0x01C2)))  // CAN2 Bus Timing reg0 (default=$00)
#define _CANBTR30   (*((volatile uchar*) (0x0202)))  // CAN3 Bus Timing reg0 (default=$00)
#define _CANBTR40   (*((volatile uchar*) (0x0282)))  // CAN4 Bus Timing reg0 (default=$00)
#define _SJW1        128                             // adjust bit length
#define _SJW0        64                              // 0=1 Tq clock cycle, 1=2, 2=3, 3=4
#define _BRP5        32                              // 
#define _BRP4        16                              // 
#define _BRP3        8                               // 0=1 prescale value. 1=2, etc to 64
#define _BRP2        4                               // 
#define _BRP1        2                               // 
#define _BRP0        1                               // 

#define _CANBTR1    (*((volatile uchar*) (0x0143)))  // CAN0 Bus Timing reg1 (default=$00)
#define _CANBTR11   (*((volatile uchar*) (0x0183)))  // CAN1 Bus Timing reg1 (default=$00)
#define _CANBTR21   (*((volatile uchar*) (0x01C3)))  // CAN2 Bus Timing reg1 (default=$00)
#define _CANBTR31   (*((volatile uchar*) (0x0203)))  // CAN3 Bus Timing reg1 (default=$00)
#define _CANBTR41   (*((volatile uchar*) (0x0283)))  // CAN4 Bus Timing reg1 (default=$00)
#define _SAMP        128                             // 1=3 samples per bit, 0=1 sample
#define _TSEG22      64                              // clock cycles per bit time
#define _TSEG21      32                              // tseg2 0=1 Tq clock cycle, 1=2, etc
#define _TSEG20      16                              // 
#define _TSEG13      8                               // 
#define _TSEG12      4                               // tseg1 same as above
#define _TSEG11      2                               // bit time=((prescale value)/fcanclk)*Tq
#define _TSEG10      1                               // 

#define _CANRFLG    (*((volatile uchar*) (0x0144)))  // CAN0 Receiver flag reg (default=$00)
#define _CANRFLG1   (*((volatile uchar*) (0x0184)))  // CAN1 Receiver flag reg (default=$00)
#define _CANRFLG2   (*((volatile uchar*) (0x01C4)))  // CAN2 Receiver flag reg (default=$00)
#define _CANRFLG3   (*((volatile uchar*) (0x0204)))  // CAN3 Receiver flag reg (default=$00)
#define _CANRFLG4   (*((volatile uchar*) (0x0284)))  // CAN4 Receiver flag reg (default=$00)
#define _WUPIF       128                             // 1=dectected bus activity and req wakeup (write 1 to clear)
#define _CSCIF       64                              // 1=can changed current bus status
#define _RSTAT1      32                              // 
#define _RSTAT0      16                              // 0=RX error counter < 97, 1= < 128 but > 96, 2= < 128, 3=bus off (read only)
#define _TSTAT1      8                               // 
#define _TSTAT0      4                               // 0=TX error counter < 97, 1= < 128 but > 96, 2= < 128, 3=bus off (read only)
#define _OVRIF       2                               // 1=data overrun detected
#define _RXF         1                               // 1=RX FIFO full, new message available

#define _CANRIER    (*((volatile uchar*) (0x0145)))  // CAN0 Receiver int enable reg (default=$00)
#define _CANRIER1   (*((volatile uchar*) (0x0185)))  // CAN1 Receiver int enable reg (default=$00)
#define _CANRIER2   (*((volatile uchar*) (0x01C5)))  // CAN2 Receiver int enable reg (default=$00)
#define _CANRIER3   (*((volatile uchar*) (0x0205)))  // CAN3 Receiver int enable reg (default=$00)
#define _CANRIER4   (*((volatile uchar*) (0x0285)))  // CAN4 Receiver int enable reg (default=$00)
#define _WUPIE       128                             // 1=wake up event caused wakeup
#define _CSCIE       64                              // 1=can status change causes int req.
#define _RSTATE1     32                              //
#define _RSTATE0     16                              // 0=no CSCIF generated,1=only if rx bus off, 2=rx bus off or rxerr, 3=all state changes
#define _TSTATE1     8                               //
#define _TSTATE0     4                               // 0=no CSCIF generated,1=only if tx bus off, 2=tx bus off or txerr, 3=all state changes
#define _OVRIE       2                               // 1=overrun causes int req
#define _RXFIE       1                               // 1=rx buff full causes int req

#define _CANTFLG    (*((volatile uchar*) (0x0146)))  // CAN0 Transmitter flag reg (default=$07)
#define _CANTFLG1   (*((volatile uchar*) (0x0186)))  // CAN1 Transmitter flag reg (default=$07)
#define _CANTFLG2   (*((volatile uchar*) (0x01C6)))  // CAN2 Transmitter flag reg (default=$07)
#define _CANTFLG3   (*((volatile uchar*) (0x0206)))  // CAN3 Transmitter flag reg (default=$07)
#define _CANTFLG4   (*((volatile uchar*) (0x0286)))  // CAN4 Transmitter flag reg (default=$07)
#define _TXE2         4                              // 1=message buffer is empty, 0=full (write 1 to clear)
#define _TXE1         2                              // 
#define _TXE0         1                              // 

#define _CANTIER    (*((volatile uchar*) (0x0147)))  // CAN0 Transmitter int enable reg (default=$00)
#define _CANTIER1   (*((volatile uchar*) (0x0187)))  // CAN1 Transmitter int enable reg (default=$00)
#define _CANTIER2   (*((volatile uchar*) (0x01C7)))  // CAN2 Transmitter int enable reg (default=$00)
#define _CANTIER3   (*((volatile uchar*) (0x0207)))  // CAN3 Transmitter int enable reg (default=$00)
#define _CANTIER4   (*((volatile uchar*) (0x0287)))  // CAN4 Transmitter int enable reg (default=$00)
#define _TXEIE2       4                              // 1=transmitter empty causes int req
#define _TXEIE1       2                              // 
#define _TXEIE0       1                              // 

#define _CANTARQ    (*((volatile uchar*) (0x0148)))  // CAN0 Transmitter message abort control reg (default=$00)
#define _CANTARQ1   (*((volatile uchar*) (0x0188)))  // CAN1 Transmitter message abort control reg (default=$00)
#define _CANTARQ2   (*((volatile uchar*) (0x01C8)))  // CAN2 Transmitter message abort control reg (default=$00)
#define _CANTARQ3   (*((volatile uchar*) (0x0208)))  // CAN3 Transmitter message abort control reg (default=$00)
#define _CANTARQ4   (*((volatile uchar*) (0x0288)))  // CAN4 Transmitter message abort control reg (default=$00)
#define _ABTRQ2       4                              // 1=abort req pending, 0=no abort pending (cleared when TXE flag set)
#define _ABTRQ1       2                              // 
#define _ABTRQ0       1                              // 

#define _CANTAAK    (*((volatile uchar*) (0x0149)))  // CAN0 Transmitter message abort control reg (default=$00)
#define _CANTAAK1   (*((volatile uchar*) (0x0189)))  // CAN1 Transmitter message abort control reg (default=$00)
#define _CANTAAK2   (*((volatile uchar*) (0x01C9)))  // CAN2 Transmitter message abort control reg (default=$00)
#define _CANTAAK3   (*((volatile uchar*) (0x0209)))  // CAN3 Transmitter message abort control reg (default=$00)
#define _CANTAAK4   (*((volatile uchar*) (0x0289)))  // CAN4 Transmitter message abort control reg (default=$00)
#define _ABTAK2       4                              // 1=acknowlege that message was aborted (cleared when TXE flag cleared)
#define _ABTAK1       2                              // 
#define _ABTAK0       1                              // 

#define _CANTBSEL   (*((volatile uchar*) (0x014A)))  // CAN0 Transmitter buffer selection reg (default=$00)
#define _CANTBSEL1  (*((volatile uchar*) (0x018A)))  // CAN1 Transmitter buffer selection reg (default=$00)
#define _CANTBSEL2  (*((volatile uchar*) (0x01CA)))  // CAN2 Transmitter buffer selection reg (default=$00)
#define _CANTBSEL3  (*((volatile uchar*) (0x020A)))  // CAN3 Transmitter buffer selection reg (default=$00)
#define _CANTBSEL4  (*((volatile uchar*) (0x028A)))  // CAN4 Transmitter buffer selection reg (default=$00)
#define _TX2          4                              // 
#define _TX1          2                              // Transmitt buffer select 0 to 2 (only lsb selects buffer)
#define _TX0          1                              // 

#define _CANIDAC    (*((volatile uchar*) (0x014B)))  // CAN0 Identifier accept control reg (default=$00)
#define _CANIDAC1   (*((volatile uchar*) (0x018B)))  // CAN1 Identifier accept control reg (default=$00)
#define _CANIDAC2   (*((volatile uchar*) (0x01CB)))  // CAN2 Identifier accept control reg (default=$00)
#define _CANIDAC3   (*((volatile uchar*) (0x020B)))  // CAN3 Identifier accept control reg (default=$00)
#define _CANIDAC4   (*((volatile uchar*) (0x028B)))  // CAN4 Identifier accept control reg (default=$00)
#define _IDAM1        32                             // 2 bits 0=2 32bit acceptence filters, 1=4, 2=8
#define _IDAM0        16                             //
#define _IDHIT2       4                              // 3 bits identifies which filter was hit
#define _IDHIT1       2                              //
#define _IDHIT0       2                              //

#define RESRV5B     (*((volatile uchar*) (0x014C)))  // Reserved (not used)
#define RESRV5C     (*((volatile uchar*) (0x014D)))  // Reserved (not used)
#define RESRV15B    (*((volatile uchar*) (0x018C)))  // Reserved (not used)
#define RESRV15C    (*((volatile uchar*) (0x018D)))  // Reserved (not used)
#define RESRV25B    (*((volatile uchar*) (0x01CC)))  // Reserved (not used)
#define RESRV25C    (*((volatile uchar*) (0x01CD)))  // Reserved (not used)
#define RESRV35B    (*((volatile uchar*) (0x020C)))  // Reserved (not used)
#define RESRV35C    (*((volatile uchar*) (0x020D)))  // Reserved (not used)
#define RESRV45B    (*((volatile uchar*) (0x028C)))  // Reserved (not used)
#define RESRV45C    (*((volatile uchar*) (0x028D)))  // Reserved (not used)

#define _CANRXERR   (*((volatile uchar*) (0x014E)))  // CAN0 Receiver error counter reg (default=$00) (read only)
#define _CANRXERR1  (*((volatile uchar*) (0x018E)))  // CAN1 Receiver error counter reg (default=$00) (read only)
#define _CANRXERR2  (*((volatile uchar*) (0x01CE)))  // CAN2 Receiver error counter reg (default=$00) (read only)
#define _CANRXERR3  (*((volatile uchar*) (0x020E)))  // CAN3 Receiver error counter reg (default=$00) (read only)
#define _CANRXERR4  (*((volatile uchar*) (0x028E)))  // CAN4 Receiver error counter reg (default=$00) (read only)
#define _RXERR7      128                             // 
#define _RXERR6      64                              // 
#define _RXERR5      32                              // 
#define _RXERR4      16                              // read this only in sleep mode (slprq=1 and slpak=1)
#define _RXERR3      8                               // 
#define _RXERR2      4                               // 
#define _RXERR1      2                               // 
#define _RXERR0      1                               // 

#define _CANTXERR   (*((volatile uchar*) (0x014F)))  // CAN0 Transmitter error counter reg (default=$00) (read only)
#define _CANTXERR1  (*((volatile uchar*) (0x018F)))  // CAN1 Transmitter error counter reg (default=$00) (read only)
#define _CANTXERR2  (*((volatile uchar*) (0x01CF)))  // CAN2 Transmitter error counter reg (default=$00) (read only)
#define _CANTXERR3  (*((volatile uchar*) (0x020F)))  // CAN3 Transmitter error counter reg (default=$00) (read only)
#define _CANTXERR4  (*((volatile uchar*) (0x028F)))  // CAN4 Transmitter error counter reg (default=$00) (read only)
#define _TXERR7      128                             // 
#define _TXERR6      64                              // 
#define _TXERR5      32                              // 
#define _TXERR4      16                              // read this only in sleep mode (slprq=1 and slpak=1)
#define _TXERR3      8                               // 
#define _TXERR2      4                               // 
#define _TXERR1      2                               // 
#define _TXERR0      1                               // 

#define _CANIDAR0   (*((volatile uchar*) (0x0150)))  // CAN0 Identifier acceptance reg0 (default=$00)
#define _CANIDAR1   (*((volatile uchar*) (0x0151)))  // CAN0 Identifier acceptance reg1 (default=$00) bank 1
#define _CANIDAR2   (*((volatile uchar*) (0x0152)))  // CAN0 Identifier acceptance reg2 (default=$00)
#define _CANIDAR3   (*((volatile uchar*) (0x0153)))  // CAN0 Identifier acceptance reg3 (default=$00)

#define _CANIDAR4   (*((volatile uchar*) (0x0158)))  // CAN0 Identifier acceptance reg4 (default=$00)
#define _CANIDAR5   (*((volatile uchar*) (0x0159)))  // CAN0 Identifier acceptance reg5 (default=$00) bank 2
#define _CANIDAR6   (*((volatile uchar*) (0x015A)))  // CAN0 Identifier acceptance reg6 (default=$00)
#define _CANIDAR7   (*((volatile uchar*) (0x015B)))  // CAN0 Identifier acceptance reg7 (default=$00)

#define _CANIDAR10  (*((volatile uchar*) (0x0190)))  // CAN1 Identifier acceptance reg0 (default=$00)
#define _CANIDAR11  (*((volatile uchar*) (0x0191)))  // CAN1 Identifier acceptance reg1 (default=$00) bank 1
#define _CANIDAR12  (*((volatile uchar*) (0x0192)))  // CAN1 Identifier acceptance reg2 (default=$00)
#define _CANIDAR13  (*((volatile uchar*) (0x0193)))  // CAN1 Identifier acceptance reg3 (default=$00)

#define _CANIDAR14  (*((volatile uchar*) (0x0198)))  // CAN1 Identifier acceptance reg4 (default=$00)
#define _CANIDAR15  (*((volatile uchar*) (0x0199)))  // CAN1 Identifier acceptance reg5 (default=$00) bank 2
#define _CANIDAR16  (*((volatile uchar*) (0x019A)))  // CAN1 Identifier acceptance reg6 (default=$00)
#define _CANIDAR17  (*((volatile uchar*) (0x019B)))  // CAN1 Identifier acceptance reg7 (default=$00)

#define _CANIDAR20  (*((volatile uchar*) (0x01D0)))  // CAN2 Identifier acceptance reg0 (default=$00)
#define _CANIDAR21  (*((volatile uchar*) (0x01D1)))  // CAN2 Identifier acceptance reg1 (default=$00) bank 1
#define _CANIDAR22  (*((volatile uchar*) (0x01D2)))  // CAN2 Identifier acceptance reg2 (default=$00)
#define _CANIDAR23  (*((volatile uchar*) (0x01D3)))  // CAN2 Identifier acceptance reg3 (default=$00)

#define _CANIDAR24  (*((volatile uchar*) (0x01D8)))  // CAN2 Identifier acceptance reg4 (default=$00)
#define _CANIDAR25  (*((volatile uchar*) (0x01D9)))  // CAN2 Identifier acceptance reg5 (default=$00) bank 2
#define _CANIDAR26  (*((volatile uchar*) (0x01DA)))  // CAN2 Identifier acceptance reg6 (default=$00)
#define _CANIDAR27  (*((volatile uchar*) (0x01DB)))  // CAN2 Identifier acceptance reg7 (default=$00)

#define _CANIDAR30  (*((volatile uchar*) (0x0210)))  // CAN3 Identifier acceptance reg0 (default=$00)
#define _CANIDAR31  (*((volatile uchar*) (0x0211)))  // CAN3 Identifier acceptance reg1 (default=$00) bank 1
#define _CANIDAR32  (*((volatile uchar*) (0x0212)))  // CAN3 Identifier acceptance reg2 (default=$00)
#define _CANIDAR33  (*((volatile uchar*) (0x0213)))  // CAN3 Identifier acceptance reg3 (default=$00)

#define _CANIDAR34  (*((volatile uchar*) (0x0218)))  // CAN3 Identifier acceptance reg4 (default=$00)
#define _CANIDAR35  (*((volatile uchar*) (0x0219)))  // CAN3 Identifier acceptance reg5 (default=$00) bank 2
#define _CANIDAR36  (*((volatile uchar*) (0x021A)))  // CAN3 Identifier acceptance reg6 (default=$00)
#define _CANIDAR37  (*((volatile uchar*) (0x021B)))  // CAN3 Identifier acceptance reg7 (default=$00)

#define _CANIDAR40  (*((volatile uchar*) (0x0290)))  // CAN4 Identifier acceptance reg0 (default=$00)
#define _CANIDAR41  (*((volatile uchar*) (0x0291)))  // CAN4 Identifier acceptance reg1 (default=$00) bank 1
#define _CANIDAR42  (*((volatile uchar*) (0x0292)))  // CAN4 Identifier acceptance reg2 (default=$00)
#define _CANIDAR43  (*((volatile uchar*) (0x0293)))  // CAN4 Identifier acceptance reg3 (default=$00)

#define _CANIDAR44  (*((volatile uchar*) (0x0298)))  // CAN4 Identifier acceptance reg4 (default=$00)
#define _CANIDAR45  (*((volatile uchar*) (0x0299)))  // CAN4 Identifier acceptance reg5 (default=$00) bank 2
#define _CANIDAR46  (*((volatile uchar*) (0x029A)))  // CAN4 Identifier acceptance reg6 (default=$00)
#define _CANIDAR47  (*((volatile uchar*) (0x029B)))  // CAN4 Identifier acceptance reg7 (default=$00)

#define _AC7         128                             // 
#define _AC6         64                              // 
#define _AC5         32                              // 
#define _AC4         16                              // 
#define _AC3         8                               // 
#define _AC2         4                               // 
#define _AC1         2                               // 
#define _AC0         1                               // 

#define _CANIDMR0   (*((volatile uchar*) (0x0154)))  // CAN0 Identifier mask reg0 (default=$00)
#define _CANIDMR1   (*((volatile uchar*) (0x0155)))  // CAN0 Identifier mask reg1 (default=$00) bank 1
#define _CANIDMR2   (*((volatile uchar*) (0x0156)))  // CAN0 Identifier mask reg2 (default=$00)
#define _CANIDMR3   (*((volatile uchar*) (0x0157)))  // CAN0 Identifier mask reg3 (default=$00)

#define _CANIDMR4   (*((volatile uchar*) (0x015C)))  // CAN0 Identifier mask reg4 (default=$00)
#define _CANIDMR5   (*((volatile uchar*) (0x015D)))  // CAN0 Identifier mask reg5 (default=$00) bank 2
#define _CANIDMR6   (*((volatile uchar*) (0x015E)))  // CAN0 Identifier mask reg6 (default=$00)
#define _CANIDMR7   (*((volatile uchar*) (0x015F)))  // CAN0 Identifier mask reg7 (default=$00)

#define _CANIDMR10  (*((volatile uchar*) (0x0194)))  // CAN1 Identifier mask reg0 (default=$00)
#define _CANIDMR11  (*((volatile uchar*) (0x0195)))  // CAN1 Identifier mask reg1 (default=$00) bank 1
#define _CANIDMR12  (*((volatile uchar*) (0x0196)))  // CAN1 Identifier mask reg2 (default=$00)
#define _CANIDMR13  (*((volatile uchar*) (0x0197)))  // CAN1 Identifier mask reg3 (default=$00)

#define _CANIDMR14  (*((volatile uchar*) (0x019C)))  // CAN1 Identifier mask reg4 (default=$00)
#define _CANIDMR15  (*((volatile uchar*) (0x019D)))  // CAN1 Identifier mask reg5 (default=$00) bank 2
#define _CANIDMR16  (*((volatile uchar*) (0x019E)))  // CAN1 Identifier mask reg6 (default=$00)
#define _CANIDMR17  (*((volatile uchar*) (0x019F)))  // CAN1 Identifier mask reg7 (default=$00)

#define _CANIDMR20  (*((volatile uchar*) (0x01D4)))  // CAN2 Identifier mask reg0 (default=$00)
#define _CANIDMR21  (*((volatile uchar*) (0x01D5)))  // CAN2 Identifier mask reg1 (default=$00) bank 1
#define _CANIDMR22  (*((volatile uchar*) (0x01D6)))  // CAN2 Identifier mask reg2 (default=$00)
#define _CANIDMR23  (*((volatile uchar*) (0x01D7)))  // CAN2 Identifier mask reg3 (default=$00)

#define _CANIDMR24  (*((volatile uchar*) (0x01DC)))  // CAN2 Identifier mask reg4 (default=$00)
#define _CANIDMR25  (*((volatile uchar*) (0x01DD)))  // CAN2 Identifier mask reg5 (default=$00) bank 2
#define _CANIDMR26  (*((volatile uchar*) (0x01DE)))  // CAN2 Identifier mask reg6 (default=$00)
#define _CANIDMR27  (*((volatile uchar*) (0x01DF)))  // CAN2 Identifier mask reg7 (default=$00)

#define _CANIDMR30  (*((volatile uchar*) (0x0214)))  // CAN3 Identifier mask reg0 (default=$00)
#define _CANIDMR31  (*((volatile uchar*) (0x0215)))  // CAN3 Identifier mask reg1 (default=$00) bank 1
#define _CANIDMR32  (*((volatile uchar*) (0x0216)))  // CAN3 Identifier mask reg2 (default=$00)
#define _CANIDMR33  (*((volatile uchar*) (0x0217)))  // CAN3 Identifier mask reg3 (default=$00)

#define _CANIDMR34  (*((volatile uchar*) (0x021C)))  // CAN3 Identifier mask reg4 (default=$00)
#define _CANIDMR35  (*((volatile uchar*) (0x021D)))  // CAN3 Identifier mask reg5 (default=$00) bank 2
#define _CANIDMR36  (*((volatile uchar*) (0x021E)))  // CAN3 Identifier mask reg6 (default=$00)
#define _CANIDMR37  (*((volatile uchar*) (0x021F)))  // CAN3 Identifier mask reg7 (default=$00)

#define _CANIDMR40  (*((volatile uchar*) (0x0294)))  // CAN4 Identifier mask reg0 (default=$00)
#define _CANIDMR41  (*((volatile uchar*) (0x0295)))  // CAN4 Identifier mask reg1 (default=$00) bank 1
#define _CANIDMR42  (*((volatile uchar*) (0x0296)))  // CAN4 Identifier mask reg2 (default=$00)
#define _CANIDMR43  (*((volatile uchar*) (0x0297)))  // CAN4 Identifier mask reg3 (default=$00)

#define _CANIDMR44  (*((volatile uchar*) (0x029C)))  // CAN4 Identifier mask reg4 (default=$00)
#define _CANIDMR45  (*((volatile uchar*) (0x029D)))  // CAN4 Identifier mask reg5 (default=$00) bank 2
#define _CANIDMR46  (*((volatile uchar*) (0x029E)))  // CAN4 Identifier mask reg6 (default=$00)
#define _CANIDMR47  (*((volatile uchar*) (0x029F)))  // CAN4 Identifier mask reg7 (default=$00)

#define _AM7         128                             // 
#define _AM6         64                              // 
#define _AM5         32                              // 
#define _AM4         16                              // 
#define _AM3         8                               // 
#define _AM2         4                               // 
#define _AM1         2                               // 
#define _AM0         1                               //


#define _CANIDR0   (*((volatile uchar*) (0x0160)))  // CAN0 RX Identifier  reg0 (default=$00)
#define _CANIDR1   (*((volatile uchar*) (0x0161)))  // CAN0 RX Identifier  reg1 (default=$00) 
#define _CANIDR2   (*((volatile uchar*) (0x0162)))  // CAN0 RX Identifier  reg2 (default=$00)
#define _CANIDR3   (*((volatile uchar*) (0x0163)))  // CAN0 RX Identifier  reg3 (default=$00)

#define _CANDSR0   (*((volatile uchar*) (0x0164)))  // CAN0 RX DATA SEG reg0 (default=$00)
#define _CANDSR1   (*((volatile uchar*) (0x0165)))  // CAN0 RX DATA SEG reg1 (default=$00) 
#define _CANDSR2   (*((volatile uchar*) (0x0166)))  // CAN0 RX DATA SEG reg2 (default=$00)
#define _CANDSR3   (*((volatile uchar*) (0x0167)))  // CAN0 RX DATA SEG reg3 (default=$00)
#define _CANDSR4   (*((volatile uchar*) (0x0168)))  // CAN0 RX DATA SEG reg4 (default=$00)
#define _CANDSR5   (*((volatile uchar*) (0x0169)))  // CAN0 RX DATA SEG reg5 (default=$00) 
#define _CANDSR6   (*((volatile uchar*) (0x016A)))  // CAN0 RX DATA SEG reg6 (default=$00)
#define _CANDSR7   (*((volatile uchar*) (0x016B)))  // CAN0 RX DATA SEG reg7 (default=$00)

#define _CANRDLR   (*((volatile uchar*) (0x016C)))  // CAN0 RX DATA LENGTH REG (default=$00)
#define _CANRTBP   (*((volatile uchar*) (0x016D)))  // CAN0 RX TRANSMIT BUFFER PRIORITY REG (default=$00) 
#define _CANRTSH   (*((volatile uchar*) (0x016E)))  // CAN0 RX TIME STAMP REG HIGH BYTE (default=$00)
#define _CANRTSL   (*((volatile uchar*) (0x016F)))  // CAN0 RX TIME STAMP REG HIGH BYTE (default=$00)




#define _CANIDT0   (*((volatile uchar*) (0x0170)))  // CAN0 TX Identifier  reg0 (default=$00)
#define _CANIDT1   (*((volatile uchar*) (0x0171)))  // CAN0 TX Identifier  reg1 (default=$00) 
#define _CANIDT2   (*((volatile uchar*) (0x0172)))  // CAN0 TX Identifier  reg2 (default=$00)
#define _CANIDT3   (*((volatile uchar*) (0x0173)))  // CAN0 TX Identifier  reg3 (default=$00)

#define _CANDST0   (*((volatile uchar*) (0x0174)))  // CAN0 TX DATA SEG reg0 (default=$00)
#define _CANDST1   (*((volatile uchar*) (0x0175)))  // CAN0 TX DATA SEG reg1 (default=$00) 
#define _CANDST2   (*((volatile uchar*) (0x0176)))  // CAN0 TX DATA SEG reg2 (default=$00)
#define _CANDST3   (*((volatile uchar*) (0x0177)))  // CAN0 TX DATA SEG reg3 (default=$00)
#define _CANDST4   (*((volatile uchar*) (0x0178)))  // CAN0 TX DATA SEG reg4 (default=$00)
#define _CANDST5   (*((volatile uchar*) (0x0179)))  // CAN0 TX DATA SEG reg5 (default=$00) 
#define _CANDST6   (*((volatile uchar*) (0x017A)))  // CAN0 TX DATA SEG reg6 (default=$00)
#define _CANDST7   (*((volatile uchar*) (0x017B)))  // CAN0 TX DATA SEG reg7 (default=$00)

#define _CANTDLR   (*((volatile uchar*) (0x017C)))  // CAN0 TX DATA LENGTH REG (default=$00)
#define _CANTTBP   (*((volatile uchar*) (0x017D)))  // CAN0 TX TRANSMIT BUFFER PRIORITY REG (default=$00) 
#define _CANTTSH   (*((volatile uchar*) (0x017E)))  // CAN0 TX TIME STAMP REG HIGH BYTE (default=$00)
#define _CANTTSL   (*((volatile uchar*) (0x017F)))  // CAN0 TX TIME STAMP REG HIGH BYTE (default=$00)

